// ManageFabric.js

// Blade Colors
bladeColor0 = "#f1cb78";
bladeColor1 = "#a7bbdd";
bladeColor2 = "#db8f8f";
bladeColor3 = "#b791ef";
bladeColor4 = "#a3d9a9";
bladeColor5 = "#bdbdbb";
bladeColor6 = "#C7FFF5";
bladeColor7 = "#80D5F8";
bladeColor8 = "#F49BC1";
bladeColor9 = "#F7977A";
bladeColor10 = "#C0DDFB";
bladeColor11 = "#FDE299";
bladeColor12 = "#C6DF9C";
bladeColor13 = "#DFD1F7";

// Mapping images
numberImage0 = "images/common/numberImages/numberImage1.gif";
numberImage1 = "images/common/numberImages/numberImage2.gif";
numberImage2 = "images/common/numberImages/numberImage3.gif";
numberImage3 = "images/common/numberImages/numberImage4.gif";
numberImage4 = "images/common/numberImages/numberImage5.gif";
numberImage5 = "images/common/numberImages/numberImage6.gif";
numberImage6 = "images/common/numberImages/numberImage7.gif";
numberImage7 = "images/common/numberImages/numberImage8.gif";
numberImage8 = "images/common/numberImages/numberImage9.gif";
numberImage9 = "images/common/numberImages/numberImage10.gif";
numberImage10 = "images/common/numberImages/numberImage11.gif";
numberImage11 = "images/common/numberImages/numberImage12.gif";
numberImage12 = "images/common/numberImages/numberImage13.gif";
numberImage13 = "images/common/numberImages/numberImage14.gif";

no_numberImage = "images/fabric/no_number.gif";

// The HTML table cell object of the selected blade
var selectedBladeNum;

var hasBeenModified = false;

function getHasBeenModified()
{
	return hasBeenModified;
}

function changeSelectedBlades(bladeNum)
{		
	// Unselect previous	
	if(selectedBladeNum != null)
	{
		document.getElementById("bladeCell" + selectedBladeNum).className = "unmappedStorage"
	}
	
	// Select new
	selectedBladeNum = bladeNum;
	document.getElementById("bladeCell" + bladeNum).className = "mappedStorage";
	document.getElementById("bladeCell" + bladeNum).style.borderColor = eval("bladeColor" + bladeNum);
}


function selectMapped(bladeNum)
{
	bladePortIDArrays = bladeIDs[bladeNum];

	// Highlight all the mapped ports
	for(x = 0; x < bladePortIDArrays.length; x++)
	{
		for(y = 0; y < bladePortIDArrays[x].length; y++)
		{						
			document.getElementById(bladePortIDArrays[x][y]).className="mappedStorage";
			document.getElementById(bladePortIDArrays[x][y]).style.borderColor = eval("bladeColor" + bladeNum);
		}
	}	
}

function deselectMapped(bladeNum)
{
	bladePortIDArrays = bladeIDs[bladeNum];
	
	// Highlight all the mapped ports
	for(x = 0; x < bladePortIDArrays.length; x++)
	{
		for(y = 0; y < bladePortIDArrays[x].length; y++)
		{			
			document.getElementById(bladePortIDArrays[x][y]).className="unmappedStorage";	
		}
	}
}

function toggleMapping(bladeNum, portID)
{
	// Set the modified flag
	hasBeenModified = true;

	bladePortIDArrays = bladeIDs[bladeNum];
	
	// See if this port is already mapped to the blade
	alreadyMapped = false;
	
	for(x = 0; x < bladePortIDArrays.length; x++)
	{		
		index = indexOf(portID, bladePortIDArrays[x]);
		
		if(index != -1)
		{
			alreadyMapped = true;
		}
	}
	
	if(alreadyMapped)
	{
		// if alreadyMapped, we need to switch the mapping to off
		// this mean to remove the port ID from all the bladeArrays
		
		// Apply the change locally
		unmap(bladeNum, portID);
		
		// Apply the change on the server
		sendUnmapRequest(bladeNum, portID);
	}
	else
	{
		// Apply the change locally
		map(bladeNum, portID);
		
		// Apply the change on the server
		sendMapRequest(bladeNum, portID);
	}
	
	// Select the blade only if one has not been selected before
	if(selectedBladeNum == null)
		changeSelectedBlades(bladeNum);
}

function map(bladeNum, portID)
{
	bladePortIDArrays = bladeIDs[bladeNum];
	
	// alert("map");
	// Make sure that this portID appears in all blade arrays
	
	for(x = 0; x < bladePortIDArrays.length; x++)
	{
		if(indexOf(portID, bladePortIDArrays[x]) == -1)
		{
			bladePortIDArrays[x].push(portID);
		}
	}
	
	// Change the mapping icon
	// alert(portID + bladeNum);
	var imgsrc = document.getElementById(portID + "" + bladeNum).src;
	imgsrc = imgsrc.substring(0,imgsrc.indexOf('images'));
	document.getElementById(portID + "" + bladeNum).src = imgsrc + eval("numberImage" + bladeNum);
}

function unmap(bladeNum, portID)
{
	bladePortIDArrays = bladeIDs[bladeNum];
	
	// alert("unmap");
	
	// Make sure that this portID appears in none of the blade arrays
	
	for(x = 0; x < bladePortIDArrays.length; x++)
	{
		index = indexOf(portID, bladePortIDArrays[x]);

		if(index != -1)
		{
			// Remove if its found
			bladePortIDArrays[x].splice(index, 1);
		}
	}
	
	// Change the mapping icon
	// alert(portID + bladeNum);
	var imgsrc = document.getElementById(portID + "" + bladeNum).src;
	imgsrc = imgsrc.substring(0,imgsrc.indexOf('images'));
	document.getElementById(portID + "" + bladeNum).src = imgsrc + no_numberImage;
}

function changeMapping(portID)
{
	// This function is called if the icon for a prot is clicked
	
	// Make sure that we have a selected blade
	if(selectedBladeNum == null)
	{
		return;
	}
	
	toggleMapping(selectedBladeNum, portID);
}

function selectAll(portList)
{
	// Make sure that we have a selected blade
	if(selectedBladeNum == null)
	{
		return;
	}
	
	// Set the modified flag
	hasBeenModified = true;
	
	// PortList will be an array of port IDs that are to be mapped
	numMapped = getNumMapped(portList, selectedBladeNum);
	
	// Check if all are alrady mapped
	if(numMapped == portList.length)
	{
		// If all are already mapped, then deselect all
		
		for(i = 0; i < portList.length; i++)
		{
			// Apply the change locally
			unmap(selectedBladeNum, portList[i]);
			
			// Apply the change on the server
			sendUnmapRequest(selectedBladeNum, portList[i]);
		}
	}
	else
	{
		// If not all are mapped, then map all
		
		for(i = 0; i < portList.length; i++)
		{
			// Apply the change locally
			map(selectedBladeNum, portList[i]);
			
			// Apply the change on the server
			sendMapRequest(selectedBladeNum, portList[i]);
		}
	}
}

function getNumMapped(portList, bladeNum)
{
	// Find how many of these ports are mapped to this blade
	
	counter = 0;
	
	bladePortIDArrays = bladeIDs[bladeNum];
	
	for(x = 0; x < bladePortIDArrays.length; x++)
	{
		for(y = 0; y < portList.length; y++)
		{			
			if(indexOf(portList[y], bladePortIDArrays[x]) != -1)
			{
				counter++;
			}
		}
	}
	
	// Since in this version ports are mapped to all blade ports (one for each switch)
	return counter / bladePortIDArrays.length;
}

function clear()
{
	// Make sure to unmap all locally
	for(i = 0; i < bladeIDs.length; i++)
	{
		for(j = 0; j < bladeIDs[i].length; j++)
		{
			while(bladeIDs[i][j].length > 0)
			{
				bladePortIndex = i;
				mappedPortID = bladeIDs[i][j].pop();
				
				unmap(bladePortIndex, mappedPortID);
			}
		}	
	}
	
	// Clear on the server
	sendClearRequest();
}


//////////////////////////////////////// AJAX FUNCTIONS ////////////////////////////////////////////////////////

function sendMapRequest(bladeNum, portID)
{
	bladePortIDArrays = bladePortNames[bladeNum];
	
	var mappings = "";
	
	for(z = 0; z < bladePortIDArrays.length; z++)
	{
		bladePort = bladePortIDArrays[z];
		
		mappings += "map=" + bladePort + "mapsto" + portID + "&";
	}
	
	requestObject = makeHttpRequestObject();

	requestObject.open("GET", editorServletPath + '?action=map&' + mappings, true);
		
	requestObject.send(null);
}

function sendUnmapRequest(bladeNum, portID)
{
	bladePortIDArrays = bladePortNames[bladeNum];
	
	var mappings = "";
	
	for(z = 0; z < bladePortIDArrays.length; z++)
	{
		bladePort = bladePortIDArrays[z];
		
		mappings += "unmap=" + bladePort + "mapsto" + portID + "&";
	}
	
	requestObject = makeHttpRequestObject();

	requestObject.open("GET", editorServletPath + '?action=unmap&' + mappings, true);
		
	requestObject.send(null);
}

function sendClearRequest()
{
	requestObject = makeHttpRequestObject();

	requestObject.open("GET", editorServletPath + '?action=clear', true);
		
	requestObject.send(null);
}

function makeHttpRequestObject() 
{
	var xmlreq = false;

	if (window.XMLHttpRequest) 
	{
    	// Create XMLHttpRequest object in non-Microsoft browsers
    	xmlreq = new XMLHttpRequest();
	}
	else if (window.ActiveXObject) 
			{			
			    // Create XMLHttpRequest via MS ActiveX
		      	xmlreq = new ActiveXObject("Microsoft.XMLHTTP");
		  	}
  	
	return xmlreq;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////




///////////////////////////////////// HELPER FUNCTIONS ////////////////////////////////////////////////////////

function getMappings()
{
	// A function that can be used to get the current state of mappings
	
	var result = new Array();
	
	for(x = 0; x < bladeIDs.length; x++)
	{
		for(y = 0; y < bladeIDs[x].length; y++)
		{
			for(z = 0; z < bladeIDs[x][y].length; z++)
			{
				bladePort = bladePortNames[x][y];
				mappedPort = bladeIDs[x][y][z];
				
				result.push(new Array(bladePort, mappedPort));
			}
		}	
	}

	return result;
}

function indexOf(element, array)
{
	for(q = 0; q < array.length; q++)
		if(array[q] == element)
			return q;
			
	return -1;
}