// ManageFabricModifyPage.js

// so the user does not get the "are you sure" message when saving (they already confirm those)
var alreadyConfirmed = false;
var saveDisabled = false;
var whiteSpace = " ";

window.onbeforeunload = confirmBrowseAway;

function confirmBrowseAway()
{  
	if (self.editorFrame.getHasBeenModified() && !alreadyConfirmed) 
	{    
		// The NLS message is stored in a hidden input field
		return document.getElementById(namespace_g+"hiddenForm:navigateAwayNLSMessage").value; 
	}
}

function confirmCancel()
{
	if (self.editorFrame.getHasBeenModified()) 
	{    
		// The NLS message is stored in a hidden input field
		var answer = confirm(document.getElementById(namespace_g+"hiddenForm:confirmCancelNLSMessage").value);
		
		// To avoid a second prompt
		if(answer)
			 alreadyConfirmed = true;
			 
		return answer;
	}
	
	return true;
}

function saveAs()
{
	var selectedIndex = document.getElementById("saveAsModalForm:nonCannedConfigurationIndexMenu").value;
	// Check if they selected the active index
	if(activeIndex == selectedIndex)
	{
		document.getElementById("saveAsEqualsActive").style.display = "block";
	}
	else
	{
		document.getElementById("saveAsEqualsActive").style.display = "none";
	}
	
	document.getElementById("saveAsIndex").innerHTML = selectedIndex + whiteSpace;
	document.getElementById("saveAsModalForm:selectedIndex").value = selectedIndex;
}

function clearConfig()
{
	window.frames['editorFrame'].clear();
}

function limitInput(element, max)
{
	if(element.value.length > max)
	{
		element.value = element.value.substring(0, max);	
	}
}

function disableControlButtons()
{
	// Control buttons need to be disabled until the editor frame is finished loading
	
	// Saving the old value (just in case its always disabled due to a canned config)
	saveDisabled = document.getElementById(namespace_g+"cancelForm:saveButton").disabled;
	
	document.getElementById(namespace_g+"cancelForm:saveButton").disabled = true;
	document.getElementById(namespace_g+"cancelForm:saveAsButton").disabled = true;
	document.getElementById(namespace_g+"cancelForm:mainCancel").disabled = true;
	document.getElementById(namespace_g+"clearConfigurationButton").disabled = true;
}

function editorFrameLoaded()
{
	// Hide loading div
	document.getElementById("editorLoadingDiv").style.display = "none";	
	
	// If the editor frame loaded with a valid configuration
	// Check if the flag is not set
	if(! window.frames['editorFrame'].unsupportedConfigFlag)
	{	
		// Restore initial value for save button
		document.getElementById(namespace_g+"cancelForm:saveButton").disabled = saveDisabled;
		
		document.getElementById(namespace_g+"cancelForm:saveAsButton").disabled = false;
		document.getElementById(namespace_g+"cancelForm:mainCancel").disabled = false;
		document.getElementById(namespace_g+"clearConfigurationButton").disabled = false;
	}
	else
	{
		// The flag was set, indicating that an unsupported config was loaded
		// Show only the cancel button, and leave everything else disabled
		
		document.getElementById(namespace_g+"cancelForm:mainCancel").disabled = false;
	}
}

function includeMappings()
{
	// A function that can be used to include the current state of the editor frame on the page
	
	// Get the mappings from the editor frame, and include them in the information
	// in hidden inputs on the page so that is sent to the server
	var mappings = window.frames['editorFrame'].getMappings();
	
	container = document.getElementById(namespace_g+"mappingsDiv");
	
	// Clear the contents
	container.innerHTML = "";
	
	for(x = 0; x < mappings.length; x++)
	{
		var newHiddenInput = document.createElement("input");
		
		newHiddenInput.setAttribute("type", "hidden");
		newHiddenInput.setAttribute("name", "mappings");
		// NOTE: this string will be tokenized using the ' maps to ' string, to parse out the source and destination ID
		newHiddenInput.setAttribute("value", mappings[x][0] + " maps to " + mappings[x][1]);
			
		container.appendChild(newHiddenInput);
	}
}

function validateSaveInput(){
	var nickname = document.getElementById(namespace_g+"saveModalForm:saveModalConfigurationNickname");
	var description = document.getElementById(namespace_g+"saveModalForm:saveModalConfigurationDescription");
	
	var errorLabel = document.getElementById(namespace_g+"saveModalForm:mf_modify_page_mf_save_invalid_input_msg");
	
	clearModal(nickname,description,errorLabel);
	
	if (!commonValidateInput(nickname.value)) {
		errorLabel.innerHTML = document.getElementById(namespace_g+"nicknameUnexceptedCharactersMsg").innerHTML;
		errorLabel.style.color="red";
		nickname.className = "inputText_Error";
		return false;
	}
	
	if (!commonValidateInput(description.value)) {
		errorLabel.innerHTML = document.getElementById(namespace_g+"descriptionUnexceptedCharactersMsg").innerHTML;
		errorLabel.style.color="red";
		description.className = "inputText_Error";
		return false;
	}
	
	return true;
	
}


function validateSaveAsInput(){
	var nickname = document.getElementById(namespace_g+"saveAsModalForm:saveAsModalConfigurationNickname");
	var description = document.getElementById(namespace_g+"saveAsModalForm:saveAsModalConfigurationDescription");
	var errorLabel = document.getElementById(namespace_g+"saveAsModalForm:mf_modify_page_mf_saveas_invalid_input_msg");
	
	clearModal(nickname,description,errorLabel);
	
	if (!commonValidateInput(nickname.value)) {
		errorLabel.innerHTML = document.getElementById(namespace_g+"nicknameUnexceptedCharactersMsg").innerHTML;
		errorLabel.style.color="red";
		nickname.className = "inputText_Error";
		return false;
	}
	
	if (!commonValidateInput(description.value)) {
		errorLabel.innerHTML = document.getElementById(namespace_g+"descriptionUnexceptedCharactersMsg").innerHTML;
		errorLabel.style.color="red";
		description.className = "inputText_Error";
		return false;
	}
	
	saveAs();
	return true;
	
}

function clearModal(nickname,description, errorLabel){
	errorLabel.style.color="";
	errorLabel.innerHTML="";
	nickname.className="inputText";
	description.className="inputText";
}

function initSaveModal(){
	var nickname = document.getElementById(namespace_g+"saveModalForm:saveModalConfigurationNickname");
	var description = document.getElementById(namespace_g+"saveModalForm:saveModalConfigurationDescription");
	var errorLabel = document.getElementById(namespace_g+"saveModalForm:mf_modify_page_mf_save_invalid_input_msg");
	nickname.value = configNickname;
	description.value = configDescription;
	clearModal(nickname,description,errorLabel);
}

function initSaveAsModal(){
	var nickname = document.getElementById(namespace_g+"saveAsModalForm:saveAsModalConfigurationNickname");
	var description = document.getElementById(namespace_g+"saveAsModalForm:saveAsModalConfigurationDescription");
	var errorLabel = document.getElementById(namespace_g+"saveAsModalForm:mf_modify_page_mf_saveas_invalid_input_msg");
	nickname.value = configNickname;
	description.value = configDescription;
	clearModal(nickname,description,errorLabel);
	
}