/**
 * Base.js
 */

// Define the package
var com={};
com.ibm={};
com.ibm.sysmgmt={};
com.ibm.sysmgmt.nbce={};
com.ibm.sysmgmt.nbce.gui={};
com.ibm.sysmgmt.nbce.gui.updatefirmware={};


var namespace_ajax = "view:"; 	
/**
 *This function is used for hidding the div tag
 *
 */
function hideDiv(divToClose) {
	document.getElementById(divToClose).style.display = 'none';
}

/**
 *This function is used for showing the div tag
 *
 */
function showDiv(divToShow) {
	document.getElementById(divToShow).style.display = 'block';
}

/**
 * This function gets the object document according to the frameName
 *
 */
function getFrameDocument(frameName) {	
	if (frameName == null || frameName == "") {
		return window.document;
	} else {
		return window.frames[frameName].document;
	}
}
 	
/**
 * This function clears the file input value.
 */
function clearFileValue(fileUploadId,frameName) {
	try {	
		//for IE
	 	//document.getElementById(fileUploadId).select();  
	    //document.execCommand("Delete");
	    getFrameDocument(frameName).getElementById(fileUploadId).select();
	    getFrameDocument(frameName).execCommand("Delete");
	} catch(e) {
		//for firefox
    	//document.getElementById(fileUploadId).value="";		    
		getFrameDocument(frameName).getElementById(fileUploadId).value="";
	}
}

/**
 * This function shows the wait cursor when clicking a button or a linkage.
 */
function showWaitCursor(thisObj) {
	document.body.style.cursor='wait';
	thisObj.style.cursor='wait';
}

/**
 * This function sends the request to the server side.
 *
 */
function sendRequest(){
	var url = getFrameDocument("fw_update_ajax_frame").location.pathname + "?dummy=" + (new Date()).getTime();
	com.ibm.sysmgmt.nbce.gui.updatefirmware.AjaxUtil.getInstance().ajaxSend(url, showDyncInfo);	
}

/**
 * This function shows the response information.
 *
 */
function showDyncInfo(response) {
	try {
		if (response != null) {
			var subResponse = response.substring(response.indexOf("<DIV id=\"submit_div\" style=\"display: none\">")+43, response.indexOf("</DIV>"));
			getFrameDocument("fw_update_ajax_frame").getElementById("submit_div").innerHTML = subResponse;
		}
	} catch(e) {
	}
	
	var dync_wait_msg = document.getElementById(namespace_g+"ufForm:ot_firmware_in_progress").innerHTML + " " + getFrameDocument("fw_update_ajax_frame").getElementById(namespace_ajax+"ajaxForm:deviceNameBeingUpdated").innerHTML + 
	     				document.getElementById(namespace_g+"ufForm:ot_percent_in_progress").innerHTML + " " + getFrameDocument("fw_update_ajax_frame").getElementById(namespace_ajax+"ajaxForm:percentComplete").innerHTML + "%.";		
	document.getElementById(namespace_g+"ufForm:ot_updating").innerHTML = dync_wait_msg;	
	checkStatus();	
}
	
/**
 * This function is used for checking if the installing is in the progress
 */
function checkStatus() {
	var isInstalling = getFrameDocument("fw_update_ajax_frame").getElementById(namespace_ajax+"ajaxForm:isInstalling").innerHTML;
	if ( isInstalling == "true") {
		setTimeout("sendRequest()", 5000);
	} else {
		beepWhenRefresh();
		document.getElementById(namespace_g+"ufForm:cb_install_completed_button").click();
	}
}

com.ibm.sysmgmt.nbce.gui.updatefirmware.AjaxUtil = function() {
	
	var httpRequest = null;
	
	var userCallback = null;
	
	/**
	 * This function is used to execute a series of functions and return the first succeeding one
	 *
	 */	
	tryThese = function() {
		for (var i = 0, length = arguments.length; i < length; i++) {
			var arg = arguments[i];
			try {
				returnValue = arg();
				break;
			} 
			catch (e) {}
    	}    	
    	return returnValue;
	}
	
	/**
	 * This function is used for initializing HTTPRequest
	 *
	 */
	this.ajaxInit =  function() {
		httpRequest = tryThese (
			function() {return new XMLHttpRequest()},
			function() {return new ActiveXObject('Msxml2.XMLHTTP')},
			function() {return new ActiveXObject('Microsoft.XMLHTTP')}
			) || false;
        if (!httpRequest) {
            return false;
        } else {
        	return true;
        }
	}
	
	/**
	 * This function is used to send an ajax post request to 'url' with 'data'
	 * 'callback' will be called when the request finishes.
	 */
	this.ajaxSend = function(url, callback) {
		if(httpRequest == null) {
			if(!this.ajaxInit()) {
				alert("Ajax not supported by browser.")
			}
		}

		if(url == null) {
			url = location.pathname + "?dummy=" + (new Date()).getTime();
		}

        httpRequest.open("GET", url, true); 
		if(callback) {
			userCallback = callback;
			httpRequest.onreadystatechange = function(){
				try {
					if(httpRequest.readyState == 4 && httpRequest.status == 200) {
						userCallback(httpRequest.responseText);
					}			
				}catch(e){
					userCallback(null);
				}
			}
		}
        httpRequest.setRequestHeader("Content-Type","text/html");
        httpRequest.send(null);
	}
}

com.ibm.sysmgmt.nbce.gui.updatefirmware.AjaxUtil.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.updatefirmware.AjaxUtil._instance == null){
		com.ibm.sysmgmt.nbce.gui.updatefirmware.AjaxUtil._instance = new com.ibm.sysmgmt.nbce.gui.updatefirmware.AjaxUtil();
	}
	
	return com.ibm.sysmgmt.nbce.gui.updatefirmware.AjaxUtil._instance;
};
