// UpdateFirmware.js
var expanderFileUpload = "inactive";
var switchFileUpload = "inactive";

/**
 * Define the functions of the Update Firmware Page
 */
com.ibm.sysmgmt.nbce.gui.updatefirmware.MainFrame = function() {

	// ************************************************************************ 
	// Public Methods
	// *********************************************************************** 
 
	/**
	 * When the page is loading, this function will decide 
	 * whether the FWUploadFormDiv will be show or not. 
	 * And if there are some error happened, the error message will be shown.
	 *
	 */
	this.mutipleInstallControl = function(){
	    var namespace_ajax = "view:";
		if(document.getElementById('lastRefreshTimestamp'))
		{
			document.getElementById('lastRefreshTimestamp').innerHTML = getLocalizedCurrentTime();
		}
		else
		{
			return;
		}
		
		
		
		var isInstalling = getFrameDocument("fw_update_ajax_frame").getElementById(namespace_ajax+"ajaxForm:isInstalling").innerHTML;
		
		// if there is a thread installing the firmware, it will show the progress bar
		if(isInstalling == "true"){
			setStatus(true);
			hideDiv("FWUploadFormDiv");
			showDiv("progress-div");
			setSelectedValues();
			this.initProgressInfo();				
		}else{
			setStatus(false);
			hideDiv("progress-div");
			showDiv("FWUploadFormDiv");
		}
		
		//if there are some errors happened, it will show the error message
		var isErrorOccurred = getFrameDocument("fw_update_ajax_frame").getElementById(namespace_ajax+"ajaxForm:isErrorOccurred").innerHTML;
		if ( isErrorOccurred == "true") {
			showDiv("div_failed");
			document.getElementById(namespace_g+"ufForm:ot_failed").innerHTML = getFrameDocument("fw_update_ajax_frame").getElementById(namespace_ajax+"ajaxForm:errorMessage").innerHTML;
		} else {
			hideDiv("div_failed");
		}
		
		//If the currnet chassis is not BCS, don't render the expander file upload component.
		var isBCS = document.getElementById(namespace_g+'isBCS').value;
		if (isBCS == "false") {
			hideDiv('section_expander_fileupload');
		}
		
		return true;
	}
	
	/**
	 * This function checks if the corresponding firmware files are selected.
	 *
	 */
	this.checkFileAction = function(thisObj, thisEvent) {
		//check the switch firmware
		var namespace_ajax = "view:";
		var SwtichframeDocument = getFrameDocument("fw_update_switch_frame");
		var ExpanderframeDocument = getFrameDocument("fw_update_expander_frame");
		
		if (SwtichframeDocument.getElementById(namespace_ajax+"form1:switchFileUpload").disabled == false ) {
			var filename = SwtichframeDocument.getElementById(namespace_ajax+"form1:switchFileUpload").value;
		
			if ( filename.indexOf(".") == -1 ) {
				alert(document.getElementById(namespace_g+"ufForm:ot_choose_switch_file").innerHTML);
				return false;
			}				
		}
		
		//check the expander firmware
		if (ExpanderframeDocument.getElementById(namespace_ajax+"form1:expanderFileUpload").disabled == false ) {
			var filename = ExpanderframeDocument.getElementById(namespace_ajax+"form1:expanderFileUpload").value;
		
			if ( filename.indexOf(".") == -1 ) {
				alert(document.getElementById(namespace_g+"ufForm:ot_choose_expander_file").innerHTML);
				return false;
			}				
		}

		return true;
	}
	
	this.completeUpload = function (frameName){
	
	   
		if (switchFileUpload == "inactive" && expanderFileUpload=="inactive"){
			return;
		}
		
		if (frameName == "switch"){
			switchFileUpload = "complete";
		}
		
		if (document.getElementById("section_expander_fileupload").style.display == "none"){			
			expanderFileUpload = "complete";
		}else{
			if (frameName == "expander"){
				expanderFileUpload = "complete";
			}
		}
		
		if (expanderFileUpload == "complete" && switchFileUpload == "complete"){
			document.getElementById(namespace_g+"ufForm:cb_install_button_hidden").click();
		}
	}

	/**
	 * This function submits the installing request.
	 *
	 */
	this.submitInstall = function(thisObj, thisEvent) {
		var SwtichframeDocument = getFrameDocument("fw_update_switch_frame");
		var ExpanderframeDocument = getFrameDocument("fw_update_expander_frame");
		var namespace_ifr = "view:";
		hideDiv("FWUploadFormDiv");
		showDiv("progress-div");
		setStatus(true);
		setCheckBoxHelper("switch_id");
		setCheckBoxHelper("expander_id");
		showWaitCursor(thisObj);
		
		if (switchFileUpload == "inactive") {
		   	SwtichframeDocument.getElementById(namespace_ifr +"form1:button1").click();
		   	switchFileUpload = "start";
		}
		
		
		
		if (expanderFileUpload == "inactive") {
			if (document.getElementById("section_expander_fileupload").style.display != "none"){
				ExpanderframeDocument.getElementById(namespace_ifr +"form1:button1").click();
			}
		   	expanderFileUpload = "start";
		}
		
		return true;
	}
			
	/**
	 * This function shows the dynamic information 
	 * when the server is installing the firmware.
	 *
	 */
	this.initProgressInfo = function() {
	    var namespace_ajax = "view:";
		var dync_wait_msg = document.getElementById(namespace_g+"ufForm:ot_firmware_in_progress").innerHTML + " " + getFrameDocument("fw_update_ajax_frame").getElementById(namespace_ajax+"ajaxForm:deviceNameBeingUpdated").innerHTML + 
		     				document.getElementById(namespace_g+"ufForm:ot_percent_in_progress").innerHTML + " " + getFrameDocument("fw_update_ajax_frame").getElementById(namespace_ajax+"ajaxForm:percentComplete").innerHTML + "%.";		
		document.getElementById(namespace_g+"ufForm:ot_updating").innerHTML = dync_wait_msg;
		setTimeout("sendRequest()", 5000);	
	} 

	/**
	 * This function show the wait cursor when clicking a button or a linkage.
	 */
	this.showWaitCursorPublic = function (thisObj) {
		showWaitCursor(thisObj);
	}
	
	// ************************************************************************ 
	// Private Methods
	// *********************************************************************** 
	
 	/**
 	 * This function sets the selected values to the checkboxes.
 	 *
 	 */
	function setSelectedValues(){
		var selectedStr = document.getElementById(namespace_g+"ufForm:selected_switch_list").value;
		var selectedList = selectedStr.split(",");
		for(var i=0; i < selectedList.length; i++){
			travelSet(selectedList[i], "switch_id");
		}
		selectedStr = document.getElementById(namespace_g+"ufForm:selected_expander_list").value;
		selectedList = selectedStr.split(",");
		for(var i=0; i < selectedList.length; i++){
			travelSet(selectedList[i], "expander_id");
		}		
	} 	

	/**
	 * This function travels the checkboxes and set one value to one checkbox.
	 *
	 */
 	function travelSet(selectedValue, checkBoxName) { 	
 		var elem = document.getElementsByName(checkBoxName)
	    for(i = 0; i < elem.length; i++) {
	        if ( elem[i].value == selectedValue) {
	        	elem[i].checked=true;
	        }
	    }
 	}
 	
	/**
	 * This function enable/disable the checkboxs and refresh button.
	 *
	 */
 	function setStatus(statusValue){
		document.getElementById(namespace_g+"ufForm:refreshButton").disabled = statusValue;
 		
 		var elem = document.getElementsByName("switch_id");
	    for(i = 0; i < elem.length; i++) {
	        elem[i].disabled = statusValue;
	    }
 		elem = document.getElementsByName("expander_id");
	    for(i = 0; i < elem.length; i++) {
	        elem[i].disabled = statusValue;
	    }
 	}
 	
 	/**
 	 * This function sets the selected values to the helper fields
 	 * 
 	 */
 	function setCheckBoxHelper(checkBoxName) {
 		var elem = document.getElementsByName(checkBoxName);
 		var elem_helper = document.getElementsByName(checkBoxName+"_helper");
	    for(i = 0; i < elem.length; i++) {
	        if ( elem[i].checked == true) {
	        	elem_helper[i].value = elem[i].value;
	        	elem_helper[i].checked = true;
	        }
	    }
 	}  	 	
}

com.ibm.sysmgmt.nbce.gui.updatefirmware.MainFrame.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.updatefirmware.MainFrame._instance == null){
		com.ibm.sysmgmt.nbce.gui.updatefirmware.MainFrame._instance = new com.ibm.sysmgmt.nbce.gui.updatefirmware.MainFrame();
	}
	
	return com.ibm.sysmgmt.nbce.gui.updatefirmware.MainFrame._instance;
};
