/**
 * Base.js
 */

// Define the package
var com={};
com.ibm={};
com.ibm.sysmgmt={};
com.ibm.sysmgmt.nbce={};
com.ibm.sysmgmt.nbce.gui={};
com.ibm.sysmgmt.nbce.gui.initialconfigwizard={};
 
 	
/**
 * This function is used for hidding the div tag
 *
 */
function hideDiv(divToClose) {
	document.getElementById(divToClose).style.display = "none";
} 	

/**
 * This function is used for hidding the div tag for some frame
 *
 */
function hideDiv(divToClose, frameName) {
	getFrameDocument(frameName).getElementById(divToClose).style.display = "none";
}

/**
 * This function is used for showing the div tag
 *
 */
function showDiv(divToShow) {
	document.getElementById(divToShow).style.display = "block";
}
 
/**
 * This function is used for showing the div tag for some frame
 *
 */
function showDiv(divToShow, frameName) {
	getFrameDocument(frameName).getElementById(divToShow).style.display = "block";
}

/**
 * This function gets the object document according to the frameName
 *
 */
function getFrameDocument(frameName) {	
	if (frameName == null || frameName == "") {
		return window.document;
	} else {
		return window.frames[frameName].document;
	}
}

/*
 * Get the elements in the document by tag and the name
 * tag: the tag name of finding elments
 * name: the name of finding elements
 * @Note add this function as IE can not correctly support getElementsByName().
 */
function getElementsByTagAndName(frameName,tag,name){
	 var elem = getFrameDocument(frameName).getElementsByTagName(tag);
     var arr = new Array();
     for(i = 0,iarr = 0; i < elem.length; i++) {
          att = elem[i].getAttribute("name");
          if(att == name) {
               arr[iarr] = elem[i];
               iarr++;
          }
     }
     return arr;
}

/**
 * This function checks the string if a valid string.
 * 
 */
function isValidString(str) {
	if (str != null && str != "") {
		return true;
	} else {
		return false;
	}
}
	
/**
 * This function checks the format of the time
 *
 */
function isTimeFormat(time) {
	var r = time.match(/^(\d{1,2}):(\d{1,2}):(\d{1,2})$/);
	if (r==null) return false;
	var hour = parseInt(r[1]);
	var minute = parseInt(r[2]);
	var second = parseInt(r[3]);
	
	return(hour>-1&&hour<24&&minute>-1&&minute<60&&second>-1&&second<60);
}

/**
 * This function checks the format the date
 *
 */
function isDateFormat(date) {
	var r = date.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
	if(r==null)return false; 
	var d = new Date(r[1], r[3]-1, r[4]);
	return(d.getFullYear()==r[1]&&(d.getMonth()+1)==r[3]&&d.getDate()==r[4]);
}

/**
 * This function checks the format the IP address
 *
 */
function isIPFormat(ip){	
	var ipexpr = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
	if (!ipexpr.test(ip)) return false;
	var IParray = ip.match(ipexpr);
	if (IParray != null) {
		for (var i=1; i<5; i++) {
			var octet = IParray[i];
			if (octet > 255) {
				return false;
			}	
		}
	}		
	return true;
}	
	
/**
 * Helper function to concancate input name and value
 *
 */	
function concancateNameAndValue(obj) {
	var dataString = "";

	dataString += escape(obj.name);
	dataString += "=";
	dataString += obj.value;
	
	return dataString;
}

com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil = function() {
	
	var httpRequest = null;
	
	var userCallback = null;
	
	/**
	 * This function is used to execute a series of functions and return the first succeeding one
	 *
	 */	
	tryThese = function() {
		for (var i = 0, length = arguments.length; i < length; i++) {
			var arg = arguments[i];
			try {
				returnValue = arg();
				break;
			} 
			catch (e) {}
    	}    	
    	return returnValue;
	}
	
	/**
	 * This function is used for initializing HTTPRequest
	 *
	 */
	this.ajaxInit =  function() {
		httpRequest = tryThese (
			function() {return new XMLHttpRequest()},
			function() {return new ActiveXObject('Msxml2.XMLHTTP')},
			function() {return new ActiveXObject('Microsoft.XMLHTTP')}
			) || false;
        if (!httpRequest) {
            return false;
        } else {
        	return true;
        }
	}
	
	/**
	 * This function is used to send an ajax post request to 'url' with 'data' asynchronally.
	 * 'callback' will be called when the request finishes.
	 */
	this.ajaxPost = function(url, data, callback) {
		if(httpRequest == null) {
			if(!this.ajaxInit()) {
				alert("Ajax not supported by browser.")
			}
		}

		if(url == null) {
			url = location.pathname;
		}

        httpRequest.open("POST", url, true); 
		if(callback) {
			userCallback = callback;
			httpRequest.onreadystatechange = function(){
				if(httpRequest.readyState == 4 && httpRequest.status == 200) {
					userCallback(httpRequest.responseText);
				}
			}
		}
        httpRequest.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
        httpRequest.send(data);
	}
	
	/**
	 * This function is used to send an ajax post request to 'url' with 'data' synchronally.
	 * 'callback' will be called when the request finishes.
	 */
	this.ajaxSyncPost = function(url, data, callback) {
		if(httpRequest == null) {
			if(!this.ajaxInit()) {
				alert("Ajax not supported by browser.")
			}
		}

		if(url == null) {
			url = location.pathname;
		}

        httpRequest.open("POST", url, false);
        httpRequest.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
        httpRequest.send(data);
		if(callback) {
			userCallback = callback;
			userCallback(httpRequest.responseText);
		}
	}	
}

com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil._instance == null){
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil._instance = new com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil();
	}
	
	return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil._instance;
};