// ICWAddSwitch.js

/**
 * show the help of the Add Switch page
 */
com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch = function() {

	// ************************************************************************ 
	// Private Properties
	// ************************************************************************
		
	var displayNone = "none";
	var displayBlock = "block";
	var expandaImgURL = "images/common/help/expandahelp.gif";
	var collapseaImgURL = "images/common/help/collapseahelp.gif";
				
	var IPAddressExpandaed = true;
	var LoginExpandaed = true;
	var TCPPortsExpandaed = true;
	
	var IPAddressDiv = "switch_ip_address_help_div";
	var LoginDiv = "switch_login_help_div";
	var TCPPortsDiv = "switch_tcp_ports_help_div";
			
	// ************************************************************************ 
	// Public Methods
	// ************************************************************************ 
	
	/**
	 * Init the add switch step when turn to this step 
	 *
	 */
	this.initAddSwitch = function(frameName, appliedSwitchNum) {
		changedAddSwitch(frameName, false);	
		clearLabelMessage(frameName);
		clearAddSwitch(frameName);
	}
	
	/**
	 * Validate the required fields
	 *
	 */
	this.validateAddSwitch = function(frameName) {
		var appliedSwitchNum = parseInt(getFrameDocument(frameName).getElementById("view:applied_switch_num_for_frame").value);
		var msgLabel = getFrameDocument(frameName).getElementById("view:ajax_form:ot_message_label");
		if (appliedSwitchNum == 0) {
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:ot_add_reminding").innerHTML;			
			msgLabel.style.color="red";
			return false;
		}
		
		clearLabelMessage(frameName);
		return true;
	}
		
	/**
	 * Execute the add switch
	 *
	 */
	this.executeAddSwitch = function(frameName) {
		//alert("execute add switch...");
		return true;
	}
			

	/**
	 *This function gets all the input value from passed in form
	 *
	 */		
	this.getFormData = function(formId, button) {
		var postForm = document.forms[formId];
		var dataString = "";
		
		if(postForm != null) {
			var objs = postForm.elements;
			for(var i = 0; i < objs.length; i++) {
				var obj = objs[i];
				if(obj.type == "text" || obj.type == "password" || obj.type == "hidden") {
					if(dataString != "") {
						dataString += "&";
					}
					dataString += concancateNameAndValue(obj)
				}
			} 
		}
		
		if(dataString != "") {
			dataString += "&";
		}
		dataString += concancateNameAndValue(button)
		return dataString;
	}
	
	/**
	 * Get ajax response text and act according to it.
	 *
	 */	
	this.getAddingSwitchResult = function(response) {
		document.getElementById("div_progress_indicator").style.display= "none";
		var msgLabel = document.getElementById("view:ajax_form:ot_message_label");
		if (response.indexOf("true") == 0 && response.length == 6) { 
			// if add the switch successfully, then the response will be like 'true 3' or 'true 4' (3/4 is the bayNumber).
			document.getElementById("view:applied_switch_num_for_frame").value = parseInt(document.getElementById("view:applied_switch_num_for_frame").value) + 1;
			if (document.getElementById("view:applied_switch_num_for_frame").value > 1) {
				storeValue(2);
				changedAddSwitch("", true);
				document.getElementById("view:applied_switch2_bayNumber").value = response.substring(5,6);
			} else {				
				storeValue(1);
				document.getElementById("view:applied_switch1_bayNumber").value = response.substring(5,6);
				document.getElementById("view:ajax_form:switch_apply").disabled = false;	
			}
			clearAddSwitch("");
			clearLabelMessage("");
			msgLabel.innerHTML = document.getElementById("view:ot_addswitch_success").innerHTML;
			msgLabel.style.color="green";
			parent.document.getElementById(parent.namespace_g + "wizardForm:wizard_next_button").disabled = false;
		} else {
		    // if add the switch failed, then the response will be the exception message.
			clearLabelMessage("");
			if (response != null && response != "") {
				msgLabel.innerHTML = response;
			} else {
				msgLabel.innerHTML = document.getElementById("view:ot_addswitch_failed").innerHTML;
			}
			msgLabel.style.color="red";
			document.getElementById("view:ajax_form:switch_apply").disabled = false;	
		}
	}	
	
	// ************************************************************************ 
	// Package Methods: should only be used in current module
	// ************************************************************************ 			
	
	/**
	  * Show the help content of the field Indentifier
	  */		
	this._showIPAddressHelp = function(imgObj){
		if (IPAddressExpandaed==true) {
			imgObj.src = collapseaImgURL;
			imgObj.title = document.getElementById("view:ot_collapse_alt").innerHTML;
			imgObj.alt = document.getElementById("view:ot_collapse_alt").innerHTML;
			showDiv(IPAddressDiv);
			IPAddressExpandaed = false;
		}else{
			imgObj.src = expandaImgURL;
			imgObj.title = document.getElementById("view:ot_expand_alt").innerHTML;
			imgObj.alt = document.getElementById("view:ot_expand_alt").innerHTML;
			hideDiv(IPAddressDiv);
			IPAddressExpandaed = true;
		}
	}
	
	/**
	 * Show the help content of the field Login
	 *
	 */	
	this._showLoginHelp = function(imgObj){
		if (LoginExpandaed==true) {
			imgObj.src = collapseaImgURL;
			imgObj.title = document.getElementById("view:ot_collapse_alt").innerHTML;
			imgObj.alt = document.getElementById("view:ot_collapse_alt").innerHTML;
			showDiv(LoginDiv);
			LoginExpandaed = false;
		}else{
			imgObj.src = expandaImgURL;
			imgObj.title = document.getElementById("view:ot_expand_alt").innerHTML;
			imgObj.alt = document.getElementById("view:ot_expand_alt").innerHTML;
			hideDiv(LoginDiv);
			LoginExpandaed = true;
		}
	}			
		
	/**
	 * This function is used for calling the checking method for add switch form
	 *
	 */
	this._applyAddSwitch = function(thisObj) {
		if (checkAddSwitchForm("") == false){
			return false;
		}
		clearLabelMessage("");
		document.getElementById("view:ajax_form:switch_apply").disabled = true;	
		document.getElementById("div_progress_indicator").style.display= "block";

		var url = parent.actionServletPath + '?action=addSwitch&'			
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil.getInstance().ajaxPost(url, 
			com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch.getInstance().getFormData("view:ajax_form",thisObj), 
			com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch.getInstance().getAddingSwitchResult);
		
		return true;
	}
			
	// ************************************************************************ 
	// Private Methods
	// ************************************************************************ 		

	/**
	 * Clear the add switch form fields and initializes the default input value.
	 *
	 */
	function clearAddSwitch(frameName){
		getFrameDocument(frameName).getElementById("view:ajax_form:switch_ip_address_input").value = "";
		getFrameDocument(frameName).getElementById("view:ajax_form:nick_name_input").value = "";
		getFrameDocument(frameName).getElementById("view:ajax_form:password_input").value = "";		
	}
	
	/**
	 * Clear the reminder message of the label
	 *
	 */
	function clearLabelMessage(frameName){
		getFrameDocument(frameName).getElementById("view:ajax_form:ot_message_label").style.color="";
		getFrameDocument(frameName).getElementById("view:ajax_form:ot_message_label").innerHTML = "";	
		getFrameDocument(frameName).getElementById("view:ajax_form:switch_ip_address_input").className = "inputText";
		getFrameDocument(frameName).getElementById("view:ajax_form:password_input").className = "inputText";
		getFrameDocument(frameName).getElementById("view:ajax_form:nick_name_input").className = "inputText";
	}
	
	/**
	 * Disable/Enable the add switch form fields.
	 *
	 */
	function changedAddSwitch(frameName, abledValue) {
		getFrameDocument(frameName).getElementById("view:ajax_form:switch_ip_address_input").disabled = abledValue;
		getFrameDocument(frameName).getElementById("view:ajax_form:nick_name_input").disabled = abledValue;
		getFrameDocument(frameName).getElementById("view:ajax_form:password_input").disabled = abledValue;
		getFrameDocument(frameName).getElementById("view:ajax_form:switch_apply").disabled = abledValue;	
		
		if(parent.document.getElementById(parent.namespace_g + "wizardForm:wizard_back_button")){
			parent.document.getElementById(parent.namespace_g + "wizardForm:wizard_back_button").disabled = abledValue;
		}
	}
	
	/**
	 * Check the required fields of the add switch form
	 *
	 */
	function checkAddSwitchForm(frameName) {	
		var msgLabel = getFrameDocument(frameName).getElementById("view:ajax_form:ot_message_label");
		//Check if the IP is blank.	
		var inputIPAddress = getFrameDocument(frameName).getElementById("view:ajax_form:switch_ip_address_input");
		if (inputIPAddress.value == ""){
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:ot_ip_address_empty").innerHTML;
			msgLabel.style.color="red";
			inputIPAddress.className = "inputText_Error";
			return false;
		}
		
		//Check if the IP address is valid.
		if (isIPFormat(inputIPAddress.value) == false ) {
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:ot_ip_invalid").innerHTML;
			msgLabel.style.color="red";
			inputIPAddress.className = "inputText_Error";
			return false;		
		}
		
		//Check if the nickname has more than 16 characters.	
		var nickName = getFrameDocument(frameName).getElementById("view:ajax_form:nick_name_input");
		if (nickName.value.length > 16) {
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:ot_nickname_invalid").innerHTML;
			msgLabel.style.color="red";
			nickName.className = "inputText_Error";
			return false;
		}
		
		//Check if the nickname has the unexpected charaters.
		if (!commonValidateInput(nickName.value)) {
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:ot_wrong_character_msg").innerHTML;
			msgLabel.style.color="red";
		 	nickName.className = "inputText_Error";
		 	return false;
		}
		
		//Check if the password is blank.
		var inputPwd = getFrameDocument(frameName).getElementById("view:ajax_form:password_input");
		if (inputPwd.value == ""){
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:ot_password_empty").innerHTML;
			msgLabel.style.color="red";
			inputPwd.className = "inputText_Error";
			return false;
		}
		
		return true;
	}
	
	/**
	 * Store the input value into the hidden fields.
	 *
	 */
	function storeValue(num) {
		document.getElementById("view:ajax_form:addswitch_switch"+num+"_ip_address_value").value = document.getElementById("view:ajax_form:switch_ip_address_input").value;
		document.getElementById("view:ajax_form:addswitch_switch"+num+"_nick_name_value").value = document.getElementById("view:ajax_form:nick_name_input").value;
		document.getElementById("view:ajax_form:addswitch_switch"+num+"_password_value").value = document.getElementById("view:ajax_form:password_input").value;		
	}
}

com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch._instance == null){
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch._instance = new com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch();
	}
	
	return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch._instance;
};