// ICWModifyPwd.js

/**
 * 
 */
com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd = function() {
	// ************************************************************************ 
	// Private Properties
	// ************************************************************************
		
	
	// ************************************************************************ 
	// Public Methods
	// ************************************************************************
	this.initModifyPwd = function(frameName, appliedSwitchNum) {
		getFrameDocument(frameName).getElementById("view:password_form:applied_switch_num").value = appliedSwitchNum;
		
		var switch1BayNumber = getFrameDocument(frameName).getElementById("view:password_form:applied_switch1_bayNumber").value;
		var switch2BayNumber = getFrameDocument(frameName).getElementById("view:password_form:applied_switch2_bayNumber").value;
		var radioBox = getElementsByTagAndName(frameName,"input", "password_form:apply_modifypwd_bay");
		
		if(appliedSwitchNum < 2) {
			if (switch1BayNumber == 3) {
			    radioBox[0].disabled = false;
			    radioBox[1].disabled = true;
				radioBox[0].checked = true;	
			} else {
			    radioBox[0].disabled = true;
			    radioBox[1].disabled = false;
				radioBox[1].checked = true;	
			}			
		} else {
			radioBox[0].checked = true;	
			radioBox[0].disabled = false;
			radioBox[1].disabled = false;
		}
		clearLabelMessage(frameName);
	}
	
	/**
	 * Validate the required fields
	 *
	 */
	this.validateModifyPwd = function(frameName){
		//optional step, no validation when clicking the next
		return true;
	}
		
	/**
	 * Execute the modify password
	 *
	 */
	this.executeModifyPwd = function(frameName) {
		clearLabelMessage(frameName);
		return true;
	}
	
	/**
	 * Check if the user's password needs to be checked.
	 */
	this.needCheck = function(frameName, newPwdId, confirmPwdId){
		var newPwd = getFrameDocument(frameName).getElementById(newPwdId);
		var confirmPwd = getFrameDocument(frameName).getElementById(confirmPwdId);
		if(isValidString(newPwd.value) == true || isValidString(confirmPwd.value) == true) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Call back function after modifying the password using ajax post calling
	 *
	 */
	this.getModifyPwdResult = function(response) {
		clearLabelMessage("");
		document.getElementById("view:password_form:modifypwd_apply_button").disabled = false;	
		document.getElementById("div_progress_indicator").style.display= "none";
		var msgLabel = document.getElementById("view:password_form:ot_message_label");
		if( response == "true" ) {
			var switchNumber = document.getElementById("view:password_form:switch_modifypwd_to_server").value;
			msgLabel.innerHTML = document.getElementById("view:password_form:ot_modifypwd_success").innerHTML;
			msgLabel.style.color="green";
			
			var radioBox = getElementsByTagAndName("","input", "password_form:apply_modifypwd_bay");
			if (radioBox[0].checked == true) {
				//document.getElementById("view:password_form:apply_modifypwd_bay3").value="true";
				setModifiedUserid(switchNumber);
			} else if (radioBox[1].checked == true) {
				//document.getElementById("view:password_form:apply_modifypwd_bay4").value="true";
				setModifiedUserid(switchNumber);
			}
			clearInputField("");
			return true;
		} else {
			msgLabel.innerHTML = response;
			msgLabel.style.color="red";
			if (msgLabel.innerHTML.indexOf("Old password is incorrect") > -1){
				document.getElementById("view:password_form:userid_old_password").className = "inputText_Error";
			}
			return false;
		}	
	}
		
	/**
	 *This function gets all the input value from passed in form
	 *
	 */		
	this.getFormData = function(formId, button) {
		var postForm = document.forms[formId];
		var dataString = "";
		
		if(postForm != null) {
			var objs = postForm.elements;
			for(var i = 0; i < objs.length; i++) {
				var obj = objs[i];
				if(obj.type == "text" || obj.type == "password" || obj.type == "hidden" || obj.type == "radio") {
					if(dataString != "") {
						dataString += "&";
					}
					dataString += concancateNameAndValue(obj)
				}
			} 
		}
		
		if(dataString != "") {
			dataString += "&";
		}
		dataString += concancateNameAndValue(button);
		return dataString;
	}
	
	// ************************************************************************ 
	// Package Methods: should only be used in current module
	// ************************************************************************ 			
			
	/**
	 * This function is used for calling the checking method for modifying password form
	 *
	 */
	this._applyModifyPwd = function(thisObj) {
		if (checkModifyPwd("") == false) {
			return false;
		}
		
		var appliedSwitchNum = document.getElementById("view:password_form:applied_switch_num").value;
		if (appliedSwitchNum == 1) {
			document.getElementById("view:password_form:switch_modifypwd_to_server").value = "1";
		} else {
			var switch1BayNumber = document.getElementById("view:password_form:applied_switch1_bayNumber").value;
			var radioBox = getElementsByTagAndName("","input", "password_form:apply_modifypwd_bay");
			if (radioBox[0].checked == true) {
				if (switch1BayNumber == 3){
					document.getElementById("view:password_form:switch_modifypwd_to_server").value = "1";
				} else {
					document.getElementById("view:password_form:switch_modifypwd_to_server").value = "2";
				}
			} else if (radioBox[1].checked == true) {
				if (switch1BayNumber == 3){
					document.getElementById("view:password_form:switch_modifypwd_to_server").value = "2";
				} else {
					document.getElementById("view:password_form:switch_modifypwd_to_server").value = "1";
				}
			}		
		}		
		clearLabelMessage("");
		document.getElementById("view:password_form:modifypwd_apply_button").disabled = true;	
		document.getElementById("div_progress_indicator").style.display= "block";
		
		var url = parent.actionServletPath + '?action=modifyPassword&'			
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil.getInstance().ajaxPost(url, 
			com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd.getInstance().getFormData("view:password_form",thisObj), 
			com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd.getInstance().getModifyPwdResult);
		return true;
	}
	
	// ************************************************************************ 
	// Private Methods
	// ************************************************************************

	/**
	 * Validate the required fields
	 *
	 */
	function checkModifyPwd(frameName){					
		var msgLabel = getFrameDocument(frameName).getElementById("view:password_form:ot_message_label");
		clearLabelMessage(frameName);
		
		var oldPwd = getFrameDocument(frameName).getElementById("view:password_form:userid_old_password");
		var userIDNewPwd = getFrameDocument(frameName).getElementById("view:password_form:userid_new_password");
		var userIDConfirmPwd = getFrameDocument(frameName).getElementById("view:password_form:userid_confirm_password");
		if(isValidString(oldPwd.value) == false && 
			(isValidString(userIDNewPwd.value) == true || 
			 isValidString(userIDConfirmPwd.value) == true) ) {
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:password_form:ot_blank_error").innerHTML;
			msgLabel.style.color="red";
			oldPwd.className = "inputText_Error";
			return false;
		}
		
		for (var i=0; i<4; i++) {
			if (i==0) {
				if(com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd.getInstance().needCheck(frameName, "view:password_form:userid_new_password", "view:password_form:userid_confirm_password") == true) {			
					if(checkPassword(frameName, "view:password_form:userid_new_password", "view:password_form:userid_confirm_password") == false) {
						return false;
					} 
				}
			} else {
				if(com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd.getInstance().needCheck(frameName, "view:password_form:userid"+i+"_new_password", "view:password_form:userid"+i+"_confirm_password") == true) {				
					if(checkPassword(frameName, "view:password_form:userid"+i+"_new_password", "view:password_form:userid"+i+"_confirm_password") == false) {
						return false;
					} 
				}			
			}
		}
		
		//need reminding message for user if user has no any inputs 
		var userNewPwdValue  = getFrameDocument(frameName).getElementById("view:password_form:userid_new_password").value;
		var user1NewPwdValue = getFrameDocument(frameName).getElementById("view:password_form:userid1_new_password").value;
		var user2NewPwdValue = getFrameDocument(frameName).getElementById("view:password_form:userid2_new_password").value;
		var user3NewPwdValue = getFrameDocument(frameName).getElementById("view:password_form:userid3_new_password").value;
		if (isValidString(userNewPwdValue) == false && isValidString(user1NewPwdValue) == false && 
		    isValidString(user2NewPwdValue) == false && isValidString(user3NewPwdValue) == false) {
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:password_form:ot_blank_error").innerHTML;
			msgLabel.style.color="red";
			getFrameDocument(frameName).getElementById("view:password_form:userid_new_password").className = "inputText_Error";
		    return false;
		}
		return true;
	}
	
	/**
	 * Check the user's password.
	 *
	 */
	function checkPassword(frameName, newPwdId, confirmPwdId) {
		//check the new password and confirm new password
		if (checkOnePwd(frameName, newPwdId) == false) {
			return false;
		}
		if (checkOnePwd(frameName, confirmPwdId) == false) {
			return false;
		}		
		if (checkNewConfirmPwd(frameName, newPwdId, confirmPwdId) == false) {
			return false;
		}
		return true;
	}	
	
	/**
	 * Just check one user's password if comply with the rules.
	 *
	 */
	function checkOnePwd(frameName, pwdId) {
		var msgLabel = getFrameDocument(frameName).getElementById("view:password_form:ot_message_label");
		var password = getFrameDocument(frameName).getElementById(pwdId);
		if(isValidString(password.value) == false) {
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:password_form:ot_blank_error").innerHTML;
			msgLabel.style.color="red";
			password.className = "inputText_Error";
			return false;
		}	
		if (password.value.length < 8 || password.value.length > 16) {
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:password_form:ot_length_error").innerHTML;
			msgLabel.style.color="red";
			password.className = "inputText_Error";
			return false;
		}
		if (password.value.match(/\d/g) == null) {
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:password_form:ot_number_error").innerHTML;
			msgLabel.style.color="red";
			password.className = "inputText_Error";
			return false;
		}
		if (password.value.match(/[a-z]/gi) == null) {
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:password_form:ot_letter_error").innerHTML;
			msgLabel.style.color="red";
			password.className = "inputText_Error";
			return false;
		}
		return true;
	}
	
	/**
	 * Just check if the new password and confirm new password are match.
	 *
	 */
	function checkNewConfirmPwd(frameName, newPwdId, confirmPwdId){
		var msgLabel = getFrameDocument(frameName).getElementById("view:password_form:ot_message_label");
		var newPwd = getFrameDocument(frameName).getElementById(newPwdId);
		var confirmPwd = getFrameDocument(frameName).getElementById(confirmPwdId);

		if(newPwd.value != confirmPwd.value){
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:password_form:ot_mismatch_error").innerHTML;
			msgLabel.style.color="red";
			newPwd.className = "inputText_Error";
			confirmPwd.className = "inputText_Error";
			return false;
		}
		return true;
	}
	
	/**
	 * Set the modified userid for summary page
	 */	
	function setModifiedUserid(switchNumber) {
		var userids = "";
		var bay3Userid = document.getElementById("view:password_form:summary_modified_bay3_userids");
		var bay4Userid = document.getElementById("view:password_form:summary_modified_bay4_userids");
		if (switchNumber == 1) {
	    	userids = bay3Userid.value;
		} else if (switchNumber == 2) {			
	    	userids = bay4Userid.value;
		}
		
		var userNewPwdValue  = document.getElementById("view:password_form:userid_new_password").value;
		var user1NewPwdValue = document.getElementById("view:password_form:userid1_new_password").value;
		var user2NewPwdValue = document.getElementById("view:password_form:userid2_new_password").value;
		var user3NewPwdValue = document.getElementById("view:password_form:userid3_new_password").value;	
		if (isValidString(userNewPwdValue) == true && userids.indexOf("USERID,") < 0 ) {
		    userids += "USERID,"
		}
		if (isValidString(user1NewPwdValue) == true && userids.indexOf("USERID1,") < 0 ) {
		    userids += "USERID1,"
		}
		if (isValidString(user2NewPwdValue) == true && userids.indexOf("USERID2,") < 0 ) {
		    userids += "USERID2,"
		}
		if (isValidString(user3NewPwdValue) == true && userids.indexOf("USERID3,") < 0 ) {
		    userids += "USERID3,"
		}
		if (switchNumber == 1) {
	    	bay3Userid.value = userids;
		} else if (switchNumber == 2) {	
	    	bay4Userid.value = userids;
		}
	}
	
	/**
	 * Clear the reminder message of the label
	 *
	 */	
	function clearLabelMessage(frameName) {	
		getFrameDocument(frameName).getElementById("view:password_form:ot_message_label").innerHTML = "";
		for (var i=0; i < 4; i++){
			if (i==0) {
				getFrameDocument(frameName).getElementById("view:password_form:userid_old_password").className = "inputText";
				getFrameDocument(frameName).getElementById("view:password_form:userid_new_password").className = "inputText";
				getFrameDocument(frameName).getElementById("view:password_form:userid_confirm_password").className = "inputText";
			} else {
				getFrameDocument(frameName).getElementById("view:password_form:userid"+i+"_new_password").className = "inputText";
				getFrameDocument(frameName).getElementById("view:password_form:userid"+i+"_confirm_password").className = "inputText";		
			}
		}
	}
	
	/**
	 * Clear the input field value
	 *
	 */	
	function clearInputField(frameName) {
		for (var i=0; i < 4; i++){
			if (i==0) {
				getFrameDocument(frameName).getElementById("view:password_form:userid_old_password").value = "";
				getFrameDocument(frameName).getElementById("view:password_form:userid_new_password").value = "";
				getFrameDocument(frameName).getElementById("view:password_form:userid_confirm_password").value = "";
			} else {
				getFrameDocument(frameName).getElementById("view:password_form:userid"+i+"_new_password").value = "";
				getFrameDocument(frameName).getElementById("view:password_form:userid"+i+"_confirm_password").value = "";
			}
		}	
	}
}

com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd._instance == null){
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd._instance = new com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd();
	}
	
	return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd._instance;
};