// ICWSetCalendar.js

/**
 * 
 */
com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar = function() {
	
	// ************************************************************************ 
	// Private Properties
	// ************************************************************************
	
	// ************************************************************************ 
	// Public Methods
	// ************************************************************************
	this.initSetCalendar = function(frameName, appliedSwitchNum) {
		getFrameDocument(frameName).getElementById("view:calendar_form:applied_switch_num").value = appliedSwitchNum;
		var setType = getSetType(frameName);
		if (setType == "ntp_server") {	
			this._setCalenadarType(frameName, "ntp_server");
		} else if (setType == "manual") {
			this._setCalenadarType(frameName, "manual");
		} else if (setType == "skip") {
			this._setCalenadarType(frameName, "skip");
		}
		setDefaultCalendar(frameName);
	}

	/**
	 * Validate the required fields
	 *
	 */
	this.validateSetCalendar = function(frameName){
		var setType = getSetType(frameName);
		if (setType == "ntp_server") {	
			return checkNTPServer(frameName);
		} else if (setType == "manual") {		
			return checkDateAndTime(frameName);
		}
	}
		
	/**
	 * Execute the set calendar
	 *
	 */
	this.executeSetCalendar = function(frameName) {
		var setType = getSetType(frameName);
		getFrameDocument(frameName).getElementById("view:calendar_form:select_set_type").value = setType;
		getFrameDocument(frameName).getElementById("view:calendar_form:set_date_str").value = getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_date").value;
		getFrameDocument(frameName).getElementById("view:calendar_form:set_time_str").value = getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_time").value;
				
		if (setType != "skip") {
			//Trigger the function this._applySetCalendar()
			getFrameDocument(frameName).getElementById("view:calendar_form:set_caendar_apply").click();		
			
			if (getFrameDocument(frameName).getElementById("view:calendar_form:ot_message_label").innerHTML != "") {
				return false;
			}
		}
		
		clearLabelMessage(frameName);
		return true;
	}

	/**
	 *This function gets all the input value from passed in form
	 *
	 */		
	this.getFormData = function(formId, button) {
		var postForm = document.forms[formId];
		var dataString = "";
		
		if(postForm != null) {
			var objs = postForm.elements;
			for(var i = 0; i < objs.length; i++) {
				var obj = objs[i];
				if(obj.type == "text" || obj.type == "hidden") {
					if(dataString != "") {
						dataString += "&";
					}
					dataString += concancateNameAndValue(obj)
				}
			} 
		}
		
		if(dataString != "") {
			dataString += "&";
		}
		dataString += concancateNameAndValue(button);
		return dataString;
	}

	/**
	 * Call back function for set calendar
	 *
	 */
	this.getSetCalendarResult = function(response) {
		if( response != "true" ) {
			document.getElementById("view:calendar_form:ot_message_label").innerHTML = response;
			return false;
		} else {
			return true;
		}		
	}			
	
	// ************************************************************************ 
	// Package Methods: should only be used in current module
	// ************************************************************************ 			
	
	/**
	 * This function reset the fields' status when user click the radio box
	 *
	 */
	this._setCalenadarType = function (frameName, setType) {
		clearLabelMessage(frameName); 		
		if (setType == "ntp_server") {
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_primary").disabled = false;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_secondary").disabled = false;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_date").disabled = true;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_time").disabled = true;
		} else if (setType == "manual") {
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_primary").disabled = true;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_secondary").disabled = true;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_date").disabled = false;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_time").disabled = false;
		} else if (setType == "skip") {
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_primary").disabled = true;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_secondary").disabled = true;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_date").disabled = true;
			getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_time").disabled = true;		
		}
	}	
	
	/**
	 * This function is used for calling the checking method for set date and time form
	 *
	 */
	this._applySetCalendar = function(thisObj) {
		var url = parent.actionServletPath + '?action=setCalendar&'			
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil.getInstance().ajaxSyncPost(url, 
			com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar.getInstance().getFormData("view:calendar_form",thisObj), 
			com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar.getInstance().getSetCalendarResult);
		
		return true;
	}

	// ************************************************************************ 
	// Private Methods
	// ************************************************************************	
	/**
	 * Set the default value to the date and time
	 */
	function setDefaultCalendar(frameName) {
	    getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_date").value = getDate();
		getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_time").value = getTime();	
	}	
	
	function getDate() {
		var current = new Date();
		var vYear = current.getFullYear();
		var vMon = current.getMonth() + 1;
		var vDay = current.getDate();
		var result = vYear + "-" + (vMon<10?("0"+vMon):vMon) + "-" + (vDay<10?("0"+vDay):vDay);
		return result;
	}
	
	function getTime(){	
		var current = new Date();
		var vHour = current.getHours();
		var vMin  = current.getMinutes();
		var vSec  = current.getSeconds();
		var result = (vHour<10?("0"+vHour):vHour) + ":" + (vMin<10?("0"+vMin):vMin) + ":" + (vSec<10?("0"+vSec):vSec);
		return result;
	}
			
	/**
	 * This function gets the set type that the user selected
	 *
	 */
	function getSetType(frameName) {
		var setType = ""; 
		var setTypeList = getFrameDocument(frameName).getElementsByName("set_type");
		for (var i=0; i<setTypeList.length; i++) {
			if(setTypeList[i].checked == true)
				setType = setTypeList[i].value;
		}
		return setType;
	}
	
	/**
	 * This function checks the NTP server format.
	 *
	 */
	function checkNTPServer(frameName) {
		var primaryNTP = getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_primary");
		var secondaryNTP = getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_secondary");
		var msgLabel = getFrameDocument(frameName).getElementById("view:calendar_form:ot_message_label");
		
		if (isValidString(primaryNTP.value) == false && isValidString(secondaryNTP.value) == false) {
			clearLabelMessage(frameName); 
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:calendar_form:ot_primary_empty").innerHTML;
			primaryNTP.className = "inputText_Error";
			return false;
		}
		if (isValidString(primaryNTP.value) == true && isIPFormat(primaryNTP.value) == false) {
			clearLabelMessage(frameName); 
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:calendar_form:ot_invalid_ip").innerHTML;
			primaryNTP.className = "inputText_Error";
			return false;
		}
		if (isValidString(secondaryNTP.value) == true && isIPFormat(secondaryNTP.value) == false) {
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:calendar_form:ot_invalid_ip").innerHTML;
			secondaryNTP.className = "inputText_Error";
			return false;
		}
		
		clearLabelMessage(frameName);
		return true;
	}

	/**
	 * This function checks the NTP server format.
	 *
	 */
	function checkDateAndTime(frameName) {
		var dateInput = getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_date");
		var timeInput = getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_time");
		var msgLabel = getFrameDocument(frameName).getElementById("view:calendar_form:ot_message_label");
					
		if(isValidString(dateInput.value) == false && isDateFormat(dateInput.value) == false ){
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:calendar_form:ot_date_empty").innerHTML;
			dateInput.className = "inputText_Error";
			return false;			
		}			
		if(isValidString(dateInput.value) == true && isDateFormat(dateInput.value) == false ){
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:calendar_form:ot_invalid_date").innerHTML;
			dateInput.className = "inputText_Error";
			return false;
		}			
		if(isValidString(timeInput.value) == true && isTimeFormat(timeInput.value) == false ){
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:calendar_form:ot_invalid_time").innerHTML;
			timeInput.className = "inputText_Error";
			return false;
		}
		
		if(isValidString(timeInput.value) == true && isValidString(dateInput.value) == false) {
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:calendar_form:ot_date_empty").innerHTML;
			dateInput.className = "inputText_Error";
			return false;
		}
		if(isValidString(timeInput.value) == false && isValidString(dateInput.value) == true ) {
			clearLabelMessage(frameName);
			msgLabel.innerHTML = getFrameDocument(frameName).getElementById("view:calendar_form:ot_time_empty").innerHTML;
			timeInput.className = "inputText_Error";
			return false;
		}
		
		clearLabelMessage(frameName);
		return true;
	}
	
	/**
	 * This function clears all the message of the remindering lable
	 *
	 */
	function clearLabelMessage(frameName) {
		getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_primary").className = "dmc_inputText";
		getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_secondary").className = "dmc_inputText";
		getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_date").className = "dmc_inputText";
		getFrameDocument(frameName).getElementById("view:calendar_form:dt_it_time").className = "dmc_inputText";
		getFrameDocument(frameName).getElementById("view:calendar_form:ot_message_label").innerHTML = "";
	}	
}

com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar._instance == null){
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar._instance = new com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar();
	}
	
	return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar._instance;
};