// InitialConfigWizard.js

/**
 * Define the functions of the Main Initial Configuration Wizard Page
 */
com.ibm.sysmgmt.nbce.gui.initialconfigwizard.MainFrame = function() {

	// ************************************************************************ 
	// Public Methods
	// *********************************************************************** 
 
    /**
     * This function is used for initializing the whole wizard page.
     * Display the first page and hide other pages.
     * 
     */
	this.init = function() {		
		new ClientPortlet();
		var index =	document.getElementById(namespace_g+"wizardForm:index_id_for_next").value;
		document.getElementById(namespace_g+"wizardForm:applied_switch_num").value = "0";
		getFrameDocument("icw_addswitch_frame").getElementById("view:applied_switch_num_for_frame").value = "0";
		
		displayContent(index);
		for(i=1; i < 6; i++) {
			showDiv("item_"+i);
		}
		
		document.getElementById(namespace_g+"wizardForm:wizard_next_button").style.visibility = "visible";
		document.getElementById(namespace_g+"wizardForm:wizard_finish_button").style.visibility = "visible";
		document.getElementById(namespace_g+"wizardForm:wizard_cancel_button").style.visibility = "visible";		
	}
		
    /**
     * This function is used for the functions of the next button
     *
     */
	this.showNextStep = function (thisObj, thisEvent) {
		var index = parseInt(document.getElementById(namespace_g+"wizardForm:index_id_for_next").value);
		var result = validateStep(index);
		if (result == false) {
			return false;
		}
		var result = executeStep(index);
		if (result == false) {
			return false;
		}
		document.getElementById(namespace_g+"wizardForm:index_id_for_next").value = index+1;
		//var ajaxUtil = com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil.getInstance();
		//ajaxUtil.ajaxPost();	
		
		var url = actionServletPath + '?action=showNextStep&'			
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil.getInstance().ajaxPost(url,'nextIndex='+(index+1),
			com.ibm.sysmgmt.nbce.gui.initialconfigwizard.MainFrame.getInstance().callbackshowNextStep);	
		
		//iframeSubmit(index);
		

		return true;
	}
	
	this.getFormData = function(formId, button) {
		var postForm = document.forms[formId];
		var dataString = "";
		
		if(postForm != null) {
			var objs = postForm.elements;
			for(var i = 0; i < objs.length; i++) {
				var obj = objs[i];
				if(obj.type == "text" || obj.type == "password" || obj.type == "hidden" || obj.type == "radio") {
					if(dataString != "") {
						dataString += "&";
					}
					dataString += concancateNameAndValue(obj)
				}
			} 
		}
		
		if(dataString != "") {
			dataString += "&";
		}
		dataString += concancateNameAndValue(button);
		return dataString;
	}
	
	this.callbackshowNextStep = function(response) {
		var index = parseInt(document.getElementById(namespace_g+"wizardForm:index_id_for_next").value);
		displayContent(index);
		initStep(index);
		initBackButton(index);
		setHelpLink(index);
	}
	
	this.callbackshowBackStep = function(response) {
		var index = parseInt(document.getElementById(namespace_g+"wizardForm:index_id_for_next").value);
		displayContent(index);
		initBackButton(index);
		setHelpLink(index);	
	}
    /**
     * This function is used for the functions of the back button
     *
     */
	this.showBackStep = function (thisObj, thisEvent) {
		var index = parseInt(document.getElementById(namespace_g+"wizardForm:index_id_for_next").value);
		document.getElementById(namespace_g+"wizardForm:index_id_for_next").value = index-1;
		var url = actionServletPath + '?action=showNextStep&'			
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AjaxUtil.getInstance().ajaxPost(url,'nextIndex='+(index-1),
			com.ibm.sysmgmt.nbce.gui.initialconfigwizard.MainFrame.getInstance().callbackshowBackStep);	
	}
	
    /**
     * This function is used for the functions of the finish button
     *
     */
	this.finishWizard = function () {
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.Summary.getInstance().executeSummary("icw_summary_frame");
		var submitButton = document.getElementById(namespace_g + "wizardForm:formSubmit");
		submitButton.click();
		return true;
	}			
			
    /**
     * This function is used for the functions of the cancel button
     *
     */
	this.cancelWizard = function () {
		var index = parseInt(document.getElementById(namespace_g+"wizardForm:index_id_for_next").value);
		if(index == 1) {
			try{
				document.getElementById("help_cancel_link").click();
			} catch (e) {
			}
			return true;
		} else {
			var submitButton = document.getElementById(namespace_g + "wizardForm:formSubmit");
			submitButton.click();
			return false;
		}
	}
			
	// ************************************************************************ 
	// Private Methods
	// ************************************************************************
		
	/**
	 * This function displays the page content and make some corresponding actions.
	 *
	 */
	function displayContent(index) {
		displayLeftMenu(index);
		changeButtonStatus(index);
		showDisplayFrame(index);	
		document.getElementById(namespace_g+"wizardForm:ot_title").innerHTML = document.getElementById(namespace_g+"wizardForm:ot_title"+index).innerHTML;
		document.getElementById(namespace_g+"wizardForm:ot_label").innerHTML = document.getElementById(namespace_g+"wizardForm:ot_label"+index).innerHTML;	
	} 
	
	/**
	 * This function display the left menu.
	 *
	 */	
	function displayLeftMenu(num){
		//showe the done items
		for (last = num-1; last >0; last--){
			document.getElementById("item_"+last).style.color = "white";
			document.getElementById("radic_"+(num-1) + "1").style.display = "";
			document.getElementById("radic_"+last + "1").style.visibility = "visible";
			document.getElementById("arr_"+last + "2").style.display = "none";
			document.getElementById(namespace_g + "wizardForm:label_"+last + "3").style.textDecoration = "";
		}
		
		//display the doing item
		document.getElementById("item_"+num).style.color = "yellow";
		document.getElementById("radic_"+num + "1").style.display = "none";
		document.getElementById("arr_"+num + "2").style.visibility = "visible";
		document.getElementById("arr_"+num + "2").style.display = "";
		document.getElementById(namespace_g + "wizardForm:label_"+num + "3").style.textDecoration = "underline";
		
		//hide the not done items
		for(id = parseInt(num,10)+1; id < 6; id++){
			document.getElementById("item_"+id).style.color = "white";
			document.getElementById("radic_"+id + "1").style.display = "none";
			document.getElementById("arr_"+id + "2").style.visibility = "hidden";
			document.getElementById(namespace_g + "wizardForm:label_"+id + "3").style.textDecoration = "";
		}		
	}
	
	/**
	 * This function changes the button status according to the showing page
	 *
	 */
	function changeButtonStatus(index){
		if ( index == 1) {
			document.getElementById(namespace_g + "wizardForm:wizard_back_button").style.visibility = "hidden";
		} else {
			document.getElementById(namespace_g + "wizardForm:wizard_back_button").style.visibility = "visible";
		}
		
		if(index == 5){
			document.getElementById(namespace_g + "wizardForm:wizard_next_button").disabled = true;
			document.getElementById(namespace_g + "wizardForm:wizard_finish_button").disabled = false;			
		} else {
		    document.getElementById(namespace_g + "wizardForm:wizard_next_button").disabled = false;
		    document.getElementById(namespace_g + "wizardForm:wizard_finish_button").disabled = true;
		}		
	}
		
    /**
     * This function displays the frameIndex's frame
     *
     */
	function showDisplayFrame(frameIndex) {
		for(var i=1; i<6; i++) {
			if (frameIndex == 3) {
				if (i == 3) {
					document.getElementById("ot_frame3").style.display = "block";
					document.getElementById("ot_frame3").style.visibility = "visible";
				} else {
					hideDiv("ot_frame"+i);
				}
			} else {
				if(i==3) {
					document.getElementById("ot_frame3").style.visibility = "hidden";	
					document.getElementById("ot_frame3").style.display = "none";				
				} else {
					if(i == frameIndex) {		
						showDiv("ot_frame"+i);
					} else {
						hideDiv("ot_frame"+i);
					}	
				}			
			}
		}		
	}
			
	/**
	 * This function is calling the init method of every wizard step
	 * @param index  the step number of the next page needed to init
	 *
	 */
	function initStep(index) {	
		var appliedSwitchNum = parseInt(document.getElementById(namespace_g + "wizardForm:applied_switch_num").value);
		switch(index){
			case 2:
				com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch.getInstance().initAddSwitch("icw_addswitch_frame", appliedSwitchNum);
				break;
			case 3:
				com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar.getInstance().initSetCalendar("icw_setcalendar_frame", appliedSwitchNum);
				break;
			case 4:
				getFrameDocument("icw_modifypwd_frame").getElementById("view:password_form:ip1_applied_address").value = getFrameDocument("icw_addswitch_frame").getElementById("view:ajax_form:addswitch_switch1_ip_address_value").value;
				getFrameDocument("icw_modifypwd_frame").getElementById("view:password_form:ip2_applied_address").value = getFrameDocument("icw_addswitch_frame").getElementById("view:ajax_form:addswitch_switch2_ip_address_value").value;
				getFrameDocument("icw_modifypwd_frame").getElementById("view:password_form:applied_switch1_bayNumber").value = getFrameDocument("icw_addswitch_frame").getElementById("view:applied_switch1_bayNumber").value;
				getFrameDocument("icw_modifypwd_frame").getElementById("view:password_form:applied_switch2_bayNumber").value = getFrameDocument("icw_addswitch_frame").getElementById("view:applied_switch2_bayNumber").value;
				
				com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd.getInstance().initModifyPwd("icw_modifypwd_frame", appliedSwitchNum);
				break;
			case 5:
				com.ibm.sysmgmt.nbce.gui.initialconfigwizard.Summary.getInstance().initSummary("icw_summary_frame", appliedSwitchNum);
				summarizeAllSteps();
				break;
		}
	}
	
	/**
	 * This function initializes the back button status when user turns to the step3 and step4.
	 *
	 */
	function initBackButton(index) {		
		var appliedSwitchNum = parseInt(document.getElementById(namespace_g + "wizardForm:applied_switch_num").value);
		switch(index){
			case 1:
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").style.visibility = "visible";
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").value = document.getElementById(namespace_g + "wizardForm:ot_cancel_label").innerHTML;
				break;
			case 2:
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").style.visibility = "visible";
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").value = document.getElementById(namespace_g + "wizardForm:ot_close_label").innerHTML;
				if(appliedSwitchNum == 0) {
					document.getElementById(namespace_g + "wizardForm:wizard_next_button").disabled = true;					
				} else {
					document.getElementById(namespace_g + "wizardForm:wizard_next_button").disabled = false;				
				}
				break;
			case 3:
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").style.visibility = "visible";
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").value = document.getElementById(namespace_g + "wizardForm:ot_close_label").innerHTML;
				if(appliedSwitchNum > 1) {
					document.getElementById(namespace_g + "wizardForm:wizard_back_button").disabled = true;
				} else {
					document.getElementById(namespace_g + "wizardForm:wizard_back_button").disabled = false;
				}
				break;
			case 4:
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").style.visibility = "visible";
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").value = document.getElementById(namespace_g + "wizardForm:ot_close_label").innerHTML;
				document.getElementById(namespace_g + "wizardForm:wizard_back_button").disabled = false;
				break;
			case 5:
				document.getElementById(namespace_g + "wizardForm:wizard_cancel_button").style.visibility = "hidden";
				break;			
		}		
	}
	
	/**
	 * This function is calling the validation method of every wizard step
	 * @param index  the step number of the current page needed to validate
	 *
	 */
	function validateStep(index) {
		document.getElementById(namespace_g + "wizardForm:applied_switch_num").value = getFrameDocument("icw_addswitch_frame").getElementById("view:applied_switch_num_for_frame").value;
		
		switch(index){
			case 2:
				return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch.getInstance().validateAddSwitch("icw_addswitch_frame");
			case 3:
				return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar.getInstance().validateSetCalendar("icw_setcalendar_frame");
			case 4:
				return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd.getInstance().validateModifyPwd("icw_modifypwd_frame");
		}
	}
	
	/**
	 * This function is calling the execute method of every wizard step
	 * @param index  the step number of the current page needed to execute
	 *
	 */
	function executeStep(index) {
		switch(index){
			case 2:
				return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.AddSwitch.getInstance().executeAddSwitch("icw_addswitch_frame");
			case 3:
				return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.SetCalendar.getInstance().executeSetCalendar("icw_setcalendar_frame");
			case 4:
				return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.ModifyPwd.getInstance().executeModifyPwd("icw_modifypwd_frame");
		}	
	}
	
	/**
	 * This function is setting the help link for every wizard step
	 * @param index  the step number of the current page
	 *
	 */
	function setHelpLink(index) {		
		var linkArr = document.getElementsByTagName("a");
		var helpLinkIndex;
		//var helpLink = "";
		for(var i=0; i<linkArr.length; i++) {
			var temp = linkArr[i].href;
			if(temp.indexOf("/ibm/console/cwm.do?.wm=help") > -1 || temp.indexOf("/help/topic/com.ibm.storage.nssm.doc/") > -1) {
				helpLinkIndex = i;
				//helpLink = temp;
				break;
			}
		}
		
		//helpLink = helpLink.substring(0, helpLink.lastIndexOf("/"));
		var helpLinkRoot = "/help/topic/com.ibm.storage.nssm.doc/";
		switch(index){
			case 1:
				var helpLink1 = helpLinkRoot + "scm_nssm_initial_configuration_wizard_help.html";
				linkArr[helpLinkIndex].href = helpLink1;
				linkArr[helpLinkIndex].onclick = function() {
					window.open(helpLink1, "helpwin", "status,resizable,scrollbars,width=740,height=290"); 
    				return false;
				}
				break;
			case 2:
				var helpLink2 = helpLinkRoot + "scm_nssm_using_initial_configuration_wizard_to_add_a_switch.html";
				linkArr[helpLinkIndex].href = helpLink2;
				linkArr[helpLinkIndex].onclick = function() {
					window.open(helpLink2, "helpwin", "status,resizable,scrollbars,width=740,height=290"); 
    				return false;
				}
				break;
			case 3:
				var helpLink3 = helpLinkRoot + "scm_nssm_setting_the_date_and_time_on_a_switch.html";
				linkArr[helpLinkIndex].href = helpLink3
				linkArr[helpLinkIndex].onclick = function() {
					window.open(helpLink3, "helpwin", "status,resizable,scrollbars,width=740,height=290"); 
    				return false;
				}
				break;
			case 4:
				var helpLink4 = helpLinkRoot + "scm_nssm_using_initial_configuration_wizard_to_modify_switch_passwords.html";	
				linkArr[helpLinkIndex].href = helpLink4;
				linkArr[helpLinkIndex].onclick = function() {
					window.open(helpLink4, "helpwin", "status,resizable,scrollbars,width=740,height=290"); 
    				return false;
				}
				break;
			case 5:
				var helpLink5 = helpLinkRoot + "scm_nssm_initial_configuration_wizard_summary_help.html";
				linkArr[helpLinkIndex].href = helpLink5;
				linkArr[helpLinkIndex].onclick = function() {
					window.open(helpLink5, "helpwin", "status,resizable,scrollbars,width=740,height=290"); 
    				return false;
				}
				break;
		}
	}
	
	/**
	 * Summarize the data of all steps.
	 */
	function summarizeAllSteps(){
		summarizeAddSwitch();
		summarizeSetCalendar();
		summarizeModifyPwd();
	}
	
	/**
	 * Summarize the data of the add switch step. 
	 */
	function summarizeAddSwitch(){
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch1_ip_address_value").innerHTML = getFrameDocument("icw_addswitch_frame").getElementById("view:ajax_form:addswitch_switch1_ip_address_value").value;
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch2_ip_address_value").innerHTML = getFrameDocument("icw_addswitch_frame").getElementById("view:ajax_form:addswitch_switch2_ip_address_value").value;

		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch1_nick_name_value").innerHTML = getFrameDocument("icw_addswitch_frame").getElementById("view:ajax_form:addswitch_switch1_nick_name_value").value;
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch2_nick_name_value").innerHTML = getFrameDocument("icw_addswitch_frame").getElementById("view:ajax_form:addswitch_switch2_nick_name_value").value;
		
		var domainPort = Number(document.getElementById("wizardForm:domain_port_id").value);				
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch1_administration_port_value").innerHTML = domainPort;
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch2_administration_port_value").innerHTML = domainPort;
		
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch1_event_port_value").innerHTML = domainPort+1;
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch2_event_port_value").innerHTML = domainPort+1;
		
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch1_firmware_download_port_value").innerHTML = domainPort+2;
		getFrameDocument("icw_summary_frame").getElementById("view:summary_switch2_firmware_download_port_value").innerHTML = domainPort+2;		
	}
	
	/**
	 * Summarize the data of the set calendar step.
	 */
	function summarizeSetCalendar(){
		var appliedSwitchNum = parseInt(document.getElementById(namespace_g + "wizardForm:applied_switch_num").value);
		var setType = ""; 
		var setTypeList = getFrameDocument("icw_setcalendar_frame").getElementsByName("set_type");
		for (var i=0; i<setTypeList.length; i++) {
			if(setTypeList[i].checked == true)
				setType = setTypeList[i].value;
		}
		
		if (setType == "ntp_server") {
			var primaryServer = getFrameDocument("icw_setcalendar_frame").getElementById("view:calendar_form:dt_it_primary").value;
			var secondaryServer = getFrameDocument("icw_setcalendar_frame").getElementById("view:calendar_form:dt_it_secondary").value;
			if (isValidString(primaryServer) == true || isValidString(secondaryServer) == true ) {								
			    if (appliedSwitchNum == 1 ) {
			    	getFrameDocument("icw_summary_frame").getElementById("summary_switch1_calendar_set").checked = true;
			    } else {
			    	getFrameDocument("icw_summary_frame").getElementById("summary_switch1_calendar_set").checked = true;
			    	getFrameDocument("icw_summary_frame").getElementById("summary_switch2_calendar_set").checked = true;
			    }
			} else {
			    getFrameDocument("icw_summary_frame").getElementById("summary_switch1_calendar_set").checked = false;
			    getFrameDocument("icw_summary_frame").getElementById("summary_switch2_calendar_set").checked = false;			
			}
		} else if (setType == "manual") {
			var dateValue = getFrameDocument("icw_setcalendar_frame").getElementById("view:calendar_form:dt_it_date").value;
			var timeValue = getFrameDocument("icw_setcalendar_frame").getElementById("view:calendar_form:dt_it_time").value;
			if (isValidString(dateValue) == true || isValidString(timeValue) == true ) {
			    if (appliedSwitchNum == 1 ) {
			    	getFrameDocument("icw_summary_frame").getElementById("summary_switch1_calendar_set").checked = true;		    
			    } else {
			    	getFrameDocument("icw_summary_frame").getElementById("summary_switch1_calendar_set").checked = true;
			    	getFrameDocument("icw_summary_frame").getElementById("summary_switch2_calendar_set").checked = true;	
			    }
			} else {
			    getFrameDocument("icw_summary_frame").getElementById("summary_switch1_calendar_set").checked = false;
			    getFrameDocument("icw_summary_frame").getElementById("summary_switch2_calendar_set").checked = false;			
			}		
		} else {
			getFrameDocument("icw_summary_frame").getElementById("summary_switch1_calendar_set").checked = false;
			getFrameDocument("icw_summary_frame").getElementById("summary_switch2_calendar_set").checked = false;		
		}
	}

	/**
	 * Summarize the data of the modify password step.
	 */
	function summarizeModifyPwd(){
		var bay3Userids = getFrameDocument("icw_modifypwd_frame").getElementById("view:password_form:summary_modified_bay3_userids").value;			
		var bay4Userids = getFrameDocument("icw_modifypwd_frame").getElementById("view:password_form:summary_modified_bay4_userids").value;
				
		if (bay3Userids != null && bay3Userids.length > 0) {
			for (var i=0; i < 4; i++) {
				if(i==0) {
					if (bay3Userids.indexOf("USERID,") > -1) {
				 		getFrameDocument("icw_summary_frame").getElementById("summary_switch1_userid_changed").checked = true;
				 	} else {
				 		getFrameDocument("icw_summary_frame").getElementById("summary_switch1_userid_changed").checked = false;
				 	}
				} else {
					if (bay3Userids.indexOf("USERID" + i + ",") > -1) {
				 		getFrameDocument("icw_summary_frame").getElementById("summary_switch1_userid"+i+"_changed").checked = true;
				 	} else {
				 		getFrameDocument("icw_summary_frame").getElementById("summary_switch1_userid"+i+"_changed").checked = false;
				 	}	
				}
			}
		}
		
		if (bay4Userids != null && bay4Userids.length > 0) {
			for (var i=0; i < 4; i++) {
				if(i==0) {
					if (bay4Userids.indexOf("USERID,") > -1) {
				 		getFrameDocument("icw_summary_frame").getElementById("summary_switch2_userid_changed").checked = true;
				 	} else {
				 		getFrameDocument("icw_summary_frame").getElementById("summary_switch2_userid_changed").checked = false;
				 	}
				} else {
					if (bay4Userids.indexOf("USERID" + i + ",") > -1) {
				 		getFrameDocument("icw_summary_frame").getElementById("summary_switch2_userid"+i+"_changed").checked = true;
				 	} else {
				 		getFrameDocument("icw_summary_frame").getElementById("summary_switch2_userid"+i+"_changed").checked = false;
				 	}		
				}
			}
		}
	}
}	

com.ibm.sysmgmt.nbce.gui.initialconfigwizard.MainFrame.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.initialconfigwizard.MainFrame._instance == null){
		com.ibm.sysmgmt.nbce.gui.initialconfigwizard.MainFrame._instance = new com.ibm.sysmgmt.nbce.gui.initialconfigwizard.MainFrame();
	}
	
	return com.ibm.sysmgmt.nbce.gui.initialconfigwizard.MainFrame._instance;
};