// SASSwitchPorts.js

var expandedImage = "images/common/tree/collapse_obj.gif";
var collapsedImage = "images/common/tree/expand_obj.gif";

var selectedPorts = new Array();
var selectedExpanders = new Array();

function disableButtons()
{
	document.getElementById("view:form1:enableButton").disabled = true;
	document.getElementById("view:form1:disableButton").disabled = true;
	document.getElementById("view:form1:propertiesButton").disabled = true;	
}

function toggle(id, image, event)
{	
    var tab = document.getElementById("TR_"+id+"-0")
    
    if (tab){
    	if (tab.style.display =="none"){
    	    var i = 0;
    	    do{
    	       tab = document.getElementById("TR_"+id+"-"+i);
    	       tab.style.display = "";
    	       i++;
    	    } while(document.getElementById("TR_"+id+"-"+i));
    		image.src = expandedImage;
			image.alt = document.getElementById("view:form1:collapse_alt").innerHTML;
			image.title = document.getElementById("view:form1:collapse_alt").innerHTML;
    	}else{
    		var i = 0;
    		do{
    	       tab = document.getElementById("TR_"+id+"-"+i);
    	       tab.style.display = "none";
    	       i++;
    	    } while(document.getElementById("TR_"+id+"-"+i));
    		image.src = collapsedImage;
			image.alt = document.getElementById("view:form1:expand_alt").innerHTML;
			image.title = document.getElementById("view:form1:expand_alt").innerHTML;
    	}
    }

	
}

function portCheckBoxClicked(checkbox)
{
	if(checkbox.checked)
	{
		// This select box was just checked
		// Add it to the list of slected items
		
		selectedPorts.push(checkbox.value);
	}
	else
	{
		// This checkbox was just unchecked
		// Remove it from the list of selected items
		
		selectedPorts.splice(indexOf(checkbox.value, selectedPorts), 1);
	}
	
	fixButtonDisable();
}

function expanderCheckBoxClicked(checkbox)
{
	if(checkbox.checked)
	{
		// This select box was just checked
		// Add it to the list of slected items
		
		selectedExpanders.push(checkbox.value);
	}
	else
	{
		// This checkbox was just unchecked
		// Remove it from the list of selected items
		
		selectedExpanders.splice(indexOf(checkbox.value, selectedExpanders), 1);
	}
	
	fixButtonDisable();
}

function fixButtonDisable()
{
	// Checking if controls have to be enabled or disabled
	
	// The properties button should only be enabled if one item is selected
	if((selectedPorts.length + selectedExpanders.length) == 1)
	{
		document.getElementById("view:form1:propertiesButton").disabled = false;
	}
	else
	{
		document.getElementById("view:form1:propertiesButton").disabled = true;
	}
	
	// The enable and disable buttons should be enabled if at least one port is checked
	if(selectedPorts.length > 0)
	{
		document.getElementById("view:form1:enableButton").disabled = false;
		document.getElementById("view:form1:disableButton").disabled = false;
	}
	else
	{
		document.getElementById("view:form1:enableButton").disabled = true;
		document.getElementById("view:form1:disableButton").disabled = true;
	}
}

function indexOf(element, array)
{
	for(x = 0; x < array.length; x++)
		if(array[x] == element)
			return x;
			
	return -1;
}

function viewProperties()
{	
	for(x = 0; x < properties.length; x++)
	{
		if(properties[x][0] == selectedPorts[0] || properties[x][0] == selectedExpanders[0])
		{
			break;
		}
	}
		
	// Make sure x is valid
	if(x == properties.length)
	{
		return;
	}
		
	// Check the type of the item selected
	if(properties[x][1] == 'BladeSlotConnection')
	{
		showBladeSlotConnectionProperties(properties[x]);
	}
	else if(properties[x][1] == 'ExternalPort')
	{
		showExternalPortProperties(properties[x]);
	}
	else if(properties[x][1] == 'DSSExpander')
	{
		showExpanderProperties(properties[x]);
	}
}

function clickedEnable()
{
	var portNames = getSelectedPortNames();
	
	list = document.getElementById("enablePortList");
	
	// Clear old list
	list.innerHTML = "";
	
	// Adding new names
	for(x = 0; x < portNames.length; x++)
	{
		newRow = document.createElement("LI");

		newRow.innerHTML = portNames[x];
			
		list.appendChild(newRow);
	}
	
	// If any expanders are selected we need to dispaly a disclaimer
	if(selectedExpanders.length > 0)
	{
		document.getElementById("enableDisclaimer").style.display = "block";
	}
	else
	{
		document.getElementById("enableDisclaimer").style.display = "none";
	}
	
	// Launch the modal
	document.getElementById("view:form1:enableLauncher").click();
}

function clickedDisable()
{
	var portNames = getSelectedPortNames();
	
	list = document.getElementById("disablePortList");
	
	// Clear old list
	list.innerHTML = "";
	
	// Adding new names
	for(x = 0; x < portNames.length; x++)
	{
		newRow = document.createElement("LI");

		newRow.innerHTML = portNames[x];
			
		list.appendChild(newRow);
	}
	
	// If any expanders are selected we need to dispaly a disclaimer
	if(selectedExpanders.length > 0)
	{
		document.getElementById("disableDisclaimer").style.display = "block";
	}
	else
	{
		document.getElementById("disableDisclaimer").style.display = "none";
	}
	
	// Launch the modal
	document.getElementById("view:form1:disableLauncher").click();
	
}

function getSelectedPortNames()
{
	var portNames = new Array();
	
	// Setting up the modal list
	for(x = 0; x < selectedPorts.length; x++)
	{
		// Find the name in the properties array using the ID
		var y = 0;
		while(properties[y][0] != selectedPorts[x])
			y++;
			
		portNames.push(properties[y][2]);
	}
	
	// Sorting
	portNames.sort();
	
	return portNames;
}

function showBladeSlotConnectionProperties(data)
{
	// Set the data in the modal
	document.getElementById("bladeSlotConnectionPropertiesPortID").innerHTML = data[2];
	document.getElementById("bladeSlotConnectionPropertiesAddress").innerHTML = data[3];
	document.getElementById("bladeSlotConnectionPropertiesType").innerHTML = data[4];
	document.getElementById("bladeSlotConnectionPropertiesEnabled").innerHTML = data[5];
	document.getElementById("bladeSlotConnectionPropertiesStatus").innerHTML = data[6];
	
	var phy = data[7][0];
		
	// Setting up the PHYs table
	document.getElementById("bladeSlotConnectionPHYPropertiesLinkRate").innerHTML = phy[0];
	document.getElementById("bladeSlotConnectionPHYPropertiesMaxLinkRate").innerHTML = phy[1];
	document.getElementById("bladeSlotConnectionPHYPropertiesIsConnected").innerHTML = phy[2];
	document.getElementById("bladeSlotConnectionPHYPropertiesPHYID").innerHTML = phy[3];
	
	
	// Show the modal
	document.getElementById("bladeSlotConnectionPropertiesLauncher").click();
}

function showExternalPortProperties(data)
{
	// Set the data in the modal
	document.getElementById("externalPortPropertiesPortID").innerHTML = data[2];
	document.getElementById("externalPortPropertiesAddress").innerHTML = data[3];
	document.getElementById("externalPortPropertiesType").innerHTML = data[4];
	document.getElementById("externalPortPropertiesRoutingSetting").innerHTML = data[5];
	document.getElementById("externalPortPropertiesEnabled").innerHTML = data[6];
	document.getElementById("externalPortPropertiesStatus").innerHTML = data[7];
	
	// Setting up the PHYs table
	var table = document.getElementById("externalPortPropertiesPHYsTable");
	var phys = data[8];
	
	// Removing all entries in the table
	while(table.rows.length > 1)
	{
		table.deleteRow(1);
	}

	// Adding the model in the correct ordering
	for(x = 0; x < phys.length; x++)
	{
		newRow = table.insertRow(x + 1);
		
		for(y = 0; y < phys[x].length; y++)
		{
			newCell = document.createElement('td');
			
			newCell.className = "nbceTableRow";
			newCell.innerHTML = phys[x][y];
			
			newRow.appendChild(newCell);
		}
	}
	
	// Show the modal
	document.getElementById("externalPortPropertiesLauncher").click();
}

function showExpanderProperties(data)
{
	// Set the data in the modal
	document.getElementById("dssExpanderPropertiesSASAddress").innerHTML = data[3];
	document.getElementById("dssExpanderPropertiesLocation").innerHTML = data[4];
	document.getElementById("dssExpanderPropertiesProductId").innerHTML = data[5];
	document.getElementById("dssExpanderPropertiesSerialNumber").innerHTML = data[6];
	document.getElementById("dssExpanderPropertiesPartNumber").innerHTML = data[7];
	document.getElementById("dssExpanderPropertiesFirmwareVersion").innerHTML = data[8];
	document.getElementById("dssExpanderPropertiesDateOfLastUpdate").innerHTML = data[9];
	document.getElementById("dssExpanderPropertiesStatus").innerHTML = data[10];
	
	// Show the modal
	document.getElementById("dssExpanderPropertiesLauncher").click();
}

function goUpdateFirmware(){


var submitButton = parent.document.getElementById(parent.namespace_g + "form1:formSubmit");
submitButton.click();
}