//UserAdministration.js

/**
 * init the page when loading the page
 */
 
function init() {
		
	showSuccess();
}

/** 
  * This function is to show the successful information when user modifies the password
  */
function showSuccess() {
	var modifyResult = document.getElementById(namespace_g+"modifyResult").value;
	if (modifyResult == "1") {        // success
		document.getElementById("div_success").style.display = 'block';
	} else if (modifyResult == "2") { // old password is wrong
		document.getElementById("div_failed").style.display = 'block';	
		document.getElementById(namespace_g+"userListform:ot_failed").innerHTML = document.getElementById("ot_modpwderror").innerHTML;				
	} else if (modifyResult == "9") { // unkown error	
		document.getElementById("div_failed").style.display = 'block';	
		document.getElementById(namespace_g+"userListform:ot_failed").innerHTML = document.getElementById("ot_modupdateerror").innerHTML;	
	}
}

/**
 * This function handles the radio button click action. when a radio button is clicked, 
 * it will get the id of the acessLevelName.
 */
function radiobuttonClick(thisObj, thisEvent) {

	var userIDs = document.getElementsByName("select_user_id");
	var rowId = 0;
	for (var i=0; i<userIDs.length; i++) {
		if (userIDs[i].checked == true) {
			rowId = i;
			break;
		}
	}
	//Get the selected accessLevelName
	var accessLevelName = namespace_g+"userListform:userTable:"+rowId+":accessLevel";
	
    buttonControl(thisObj, thisEvent, accessLevelName);
    return true;
}

/**
 * This funtion control the button to show the Modified Password panel
 */
function buttonControl(thisObj, thisEvent, accessLevelName) {
	var currentUser = document.getElementById(namespace_g+"currentUser").value;
	
	// Need to check for permissions first...
	if (canModify(thisObj, thisEvent, accessLevelName)) {
		document.getElementById(namespace_g+"userListform:btnModifyPassword").disabled = false;
	}
	
	document.getElementById(namespace_g+"passForm:dlgModifyPassword_txtUser").innerHTML = thisObj.value;
	document.getElementById(namespace_g+"passForm:ih_dlgModifyPassword_txtUser").value = thisObj.value;
}

/**
 * This function checks the permissions for the current user and decides whether to enable 
 * the Modify Password button
 */
function canModify(thisObj, thisEvent, accessLevelName){
	var currAccessLevel = document.getElementById(namespace_g+"canModify").value;  
	var selectAccessLevel = document.getElementById(accessLevelName).innerHTML;
	if (currAccessLevel > selectAccessLevel) {
		document.getElementById("div_dlgModifyPassword_txtOldPassword").style.display = 'none';
		document.getElementById("div_dlgModifyPassword_OldPassword").style.display = 'none';
		return true;
	}
	else if (currAccessLevel == selectAccessLevel) {
		document.getElementById("div_dlgModifyPassword_txtOldPassword").style.display = 'block';
		document.getElementById("div_dlgModifyPassword_OldPassword").style.display = 'block';
		return true;
	}
	else {
		document.getElementById(namespace_g+"userListform:btnModifyPassword").disabled = true;
		return false;
	}
}

/**
 * This function validates the input data of the current user
 *
 */
function checkModifyPasswords(thisObj, thisEvent){
	var passwordErrorTxtName = namespace_g+"passForm:dlgModifyPassword_txtError";
	document.getElementById(passwordErrorTxtName).innerHTML = "";
	
	var oldPwdDisplay = document.getElementById("div_dlgModifyPassword_OldPassword").style.display;
	var p0 = document.getElementById(namespace_g+"passForm:dlgModifyPassword_OldPassword").value;
	var p1 = document.getElementById(namespace_g+"passForm:dlgModifyPassword_NewPassword").value;
	var p2 = document.getElementById(namespace_g+"passForm:dlgModifyPassword_VerifyNewPassword").value;
	if(oldPwdDisplay=="block"){
		if(p0==""){
			document.getElementById(passwordErrorTxtName).innerHTML = document.getElementById(namespace_g+"ot_blankerror").innerHTML;
			return false;
		}
	}
	if(p1!=p2){
		document.getElementById(passwordErrorTxtName).innerHTML = document.getElementById(namespace_g+"ot_mismatcherror").innerHTML;
		return false;
	}
	if(p1==""||p2==""){
		document.getElementById(passwordErrorTxtName).innerHTML = document.getElementById(namespace_g+"ot_blankerror").innerHTML;
		return false;
	}
	if ((p1.length < 8) || (p1.length > 16) || (p2.length < 8) || (p2.length > 16)) {
		document.getElementById(passwordErrorTxtName).innerHTML = document.getElementById(namespace_g+"ot_lengtherror").innerHTML;
		return false;
	}
	if ((p1.match(/\d/g) == null) || (p2.match(/\d/g) == null)) {
		document.getElementById(passwordErrorTxtName).innerHTML = document.getElementById(namespace_g+"ot_numbererror").innerHTML;
		return false;
	}
	if ((p1.match(/[a-z]/gi) == null) || (p2.match(/[a-z]/gi) == null)) {
		document.getElementById(passwordErrorTxtName).innerHTML = document.getElementById(namespace_g+"ot_lettererror").innerHTML;
		return false;
	}
	document.getElementById(namespace_g+"passForm:cb_modify_cancel").disabled = true;
	document.getElementById(namespace_g+"passForm:cb_modify_button_ok").disabled = true;
	document.getElementById(namespace_g+"passForm:cb_modify_ok").click();
	return true;
}

/**
 * This function cancel the modify password action
 *
 */
function cancelAction() {
	document.getElementById(namespace_g+"passForm:dlgModifyPassword_OldPassword").value = '';
	document.getElementById(namespace_g+"passForm:dlgModifyPassword_NewPassword").value = '';
	document.getElementById(namespace_g+"passForm:dlgModifyPassword_VerifyNewPassword").value = '';
	document.getElementById(namespace_g+"passForm:dlgModifyPassword_txtError").innerHTML = '';
	return true;
}

/**
 * This function makes the focus on the first field of the modify password panel
 *
 */
function fieldFocus(thisObj, thisEvent) {
	thisObj.focus();
	if (document.getElementById("div_dlgModifyPassword_txtOldPassword").style.display == 'none') {
		document.getElementById(namespace_g+"passForm:dlgModifyPassword_NewPassword").focus();
	} else {
		document.getElementById(namespace_g+"passForm:dlgModifyPassword_OldPassword").focus();
	}
}
/*
 * This function control the help expander.
 *
 */

var expandaed = true;

function showHelp(thisObj){
		
		if (expandaed==true) {
			thisObj.src = '/scm.gui.nbce.portlet/faces/images/common/help/collapseahelp.gif';
			thisObj.alt = document.getElementById(namespace_g+"ot_collapse_alt").innerHTML;
			thisObj.title = document.getElementById(namespace_g+"ot_collapse_alt").innerHTML;
			document.getElementById('modify_password_help_div').style.display = "block";
			expandaed = false;
		}else{
			thisObj.src = "/scm.gui.nbce.portlet/faces/images/common/help/expandahelp.gif";
			thisObj.alt = document.getElementById(namespace_g+"ot_expand_alt").innerHTML;
			thisObj.title = document.getElementById(namespace_g+"ot_expand_alt").innerHTML;
			document.getElementById('modify_password_help_div').style.display = "none";
			expandaed = true;
		}
	}