/**
 * Define the Menu class 
 */
com.ibm.sysmgmt.nbce.gui.viewswitches.Menu = function(){

	// ************************************************************************ 
	// Private Fields
	// *********************************************************************** 
	var curValue;
	var selMenuItem;

	com.ibm.sysmgmt.nbce.gui.viewswitches.MenuValueChangeListener = function() {
	this.valueChanged = function(value){
		//alert(value);
		if(value==null){
			refreshMenu("Default");
		}else{
			refreshMenu(value.type);
		}
		curValue = value;
	}
	}
	com.ibm.sysmgmt.nbce.gui.viewswitches.MenuValueChangeListener.prototype = new com.ibm.sysmgmt.nbce.gui.viewswitches.ValueChangeListener();
	var menuValueChangeListener = new com.ibm.sysmgmt.nbce.gui.viewswitches.MenuValueChangeListener();
	
	// ************************************************************************ 
	// Public Methods
	// *********************************************************************** 
	this.getValueChangeListener = function(){
		return menuValueChangeListener;
	}

	// ************************************************************************ 
	// Package Methods: should only be used in current module
	// *********************************************************************** 
	this._clickMenuItem = function(menuItem){
		selMenuItem = menuItem;
		setSelectItemAndMenu(curValue,selMenuItem);
		
		
		
		switch(selMenuItem)
		{
			case "switchProperties" : com.ibm.sysmgmt.nbce.gui.viewswitches.SwitchPropertiesModal.getInstance().setSASSwitch(curValue); com.ibm.sysmgmt.nbce.gui.viewswitches.SwitchPropertiesModal.getInstance().show(); break;
			case "switchRemove" : com.ibm.sysmgmt.nbce.gui.viewswitches.RemoveSwitchModal.getInstance().setSASSwitch(curValue); com.ibm.sysmgmt.nbce.gui.viewswitches.RemoveSwitchModal.getInstance().show(); break;
			case "chassisSetDateAndTime": com.ibm.sysmgmt.nbce.gui.viewswitches.DateAndTimeModal.getInstance().show();break;
			case "switchSetDateAndTime": com.ibm.sysmgmt.nbce.gui.viewswitches.DateAndTimeModal.getInstance().show();break;
			default : startCommonWait();submitForm();break;
		}
	}

	// ************************************************************************ 
	// Private Methods
	// *********************************************************************** 
	function refreshMenu(type){
		var allMenus = getElementsByTagAndName("DIV", "menuDIV");
		var selectMenu;
		
		switch(type)
		{
			case "BCE" : selectMenu = document.getElementById("chasisMenuDIV");  break;
			case "SASSwitch" : selectMenu = document.getElementById("switchMenuDIV"); break;
			case "SupportData" : selectMenu = document.getElementById("supportDataMenuDIV");break;
			case "Default" : selectMenu = document.getElementById("defaultMenuDIV");  break;
		}
		
		//alert(this.selectedRowObject.nickName);
		for(x = 0; x < allMenus.length; x++)
		{
			allMenus[x].style.display='none';
		}
		
		selectMenu.style.display='block';
	}
	

	function submitForm(){
		document.getElementById(namespace_g + "submitForm").submit();
	}
	
	function setSelectItemAndMenu(curValue,selMenuItem)
	{  
		if (curValue.type=='BCE') {
			itemValue = curValue.domainIP; 
			
		}
		else { 
			itemValue = curValue.ipAddress;
			
		}
		
		document.getElementById(namespace_g+"submitForm:menus:selectItemType").value=curValue.type;
		//alert(curValue.type);
		//alert(document.getElementById(namespace_g+"submitForm:DateAndTimeModal:selectItemType").value);
		document.getElementById(namespace_g+"submitForm:menus:selectObject").value=itemValue;
		document.getElementById(namespace_g+"submitForm:menus:selectMenuItem").value=selMenuItem;
	}
}


// ************************************************************************ 
// Static Methods&Fields
// *********************************************************************** 
com.ibm.sysmgmt.nbce.gui.viewswitches.Menu._instance=null;

/*
 * singleton of Menu
 */
com.ibm.sysmgmt.nbce.gui.viewswitches.Menu.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.viewswitches.Menu._instance == null){
		com.ibm.sysmgmt.nbce.gui.viewswitches.Menu._instance = new com.ibm.sysmgmt.nbce.gui.viewswitches.Menu();
	}
	
	return com.ibm.sysmgmt.nbce.gui.viewswitches.Menu._instance;
};

function refreshSupportMenu(){
	var allMenus = getElementsByTagAndName("DIV", "menuDIV");
	var selectMenu = document.getElementById("supportDataMenuDIV");
	for(x = 0; x < allMenus.length; x++)
	{
		allMenus[x].style.display='none';
	}
	
	selectMenu.style.display='block';
}

function clickSupportDataMenu() {
	document.getElementById(namespace_g+"submitForm:menus:selectMenuItem").value="switchCollectSupportData";
	document.getElementById(namespace_g + "submitForm").submit();
}
