/**
 * TreeTable.js
 */
com.ibm.sysmgmt.nbce.gui.viewswitches.TreeTable = function(){
	// ************************************************************************ 
	// Private Fields
	// *********************************************************************** 
	
	var selectedRowObject = null;
	var selectedRow = null;
 	var valueChangeListenerList = new Array();
 	valueChangeListenerCount =0;
 		
	// ************************************************************************ 
	// Public Methods
	// *********************************************************************** 

	/*
	 * diplay/undisplay all braches of the treetable. 
	 * @param display display all if true, or undiplay all if false.
	 */
 	this.setAllDisplays = function(display){
		// NOTE: the prefix 'treetable_folder' is defined in the TreeTableController.
		var divName = "treetable_folder_DIV";
		var imgName ="treetable_folder_IMG";
		var treetableFolderDIVs = getElementsByTagAndName("DIV", divName);
	 	var displayConstant = 'block';
	 	
	 	if(display == 'false')
		{
			displayConstant = 'none';
		}
		
		for(x = 0; x < treetableFolderDIVs.length; x++)
		{		
			treetableFolderDIVs[x].style.display = displayConstant;
		}
	
		var treetableFolderIMGs=getElementsByTagAndName("IMG",imgName);
		for(x = 0; x < treetableFolderIMGs.length; x++)
		{		
			if(display == 'false')
			{
				treetableFolderIMGs[x].src = treetableFolderIMGs[x].src.replace('collapse_obj','expand_obj');
				treetableFolderIMGs[x].title = document.getElementById(namespace_g+"submitForm:treeTable:expand_alt").innerHTML;
				treetableFolderIMGs[x].alt = document.getElementById(namespace_g+"submitForm:treeTable:expand_alt").innerHTML;
			}
			else
			{
				treetableFolderIMGs[x].src =  treetableFolderIMGs[x].src.replace('expand_obj','collapse_obj');
				treetableFolderIMGs[x].title = document.getElementById(namespace_g+"submitForm:treeTable:collapse_alt").innerHTML;
				treetableFolderIMGs[x].alt = document.getElementById(namespace_g+"submitForm:treeTable:collapse_alt").innerHTML;
			}
		}
 	
	 	
	 	if(display == 'false')
		{
			allCollapsedFixSelected();
		}
		 	
	}
 	
 	this.addValueChangeListener = function(valueChangeListener){
 		valueChangeListenerList[valueChangeListenerCount++]=valueChangeListener;
 	}

	// ************************************************************************ 
	// Package Methods: should only be used in current module
	// *********************************************************************** 
	
	/*
	 */
	this._clickRow = function(_object,_rowId){
	
		if(selectedRow != null)
		{
			document.getElementById(selectedRow).className = "nbceTableUnselectedRow";
		}
	
		document.getElementById(_rowId).className = "nbceTableSelectedRow";

		// Setting the new selected row
		selectedRow = _rowId;
		
		
		setSelectedSwitchIpAddress(_object.ipAddress);
		
		fireValueChange(_object);
	} 

	
	
	/*
	 * Define the actions when the 'collapse' or 'expand' image is clicked
	 */
 	this._toggle = function(curRowId, childrenGroupId, image, event){
 		if(document.getElementById(childrenGroupId).style.display == "none")
		{
			document.getElementById(childrenGroupId).style.display = "block"
		
			image.src = image.src.replace('expand_obj','collapse_obj');
			image.title = document.getElementById(namespace_g+"submitForm:treeTable:collapse_alt").innerHTML;
			image.alt = document.getElementById(namespace_g+"submitForm:treeTable:collapse_alt").innerHTML;
		}
		else
		{
			document.getElementById(childrenGroupId).style.display = "none";
		
			image.src = image.src.replace('collapse_obj','expand_obj');
			image.title = document.getElementById(namespace_g+"submitForm:treeTable:expand_alt").innerHTML;
			image.alt = document.getElementById(namespace_g+"submitForm:treeTable:expand_alt").innerHTML;
		
			// Unselecting the selected row, in case an ancestor is collapsed
			elementCollapsedFixSelected(curRowId);
		}
	
		// So that the row isnt selected by toggling
		stopPropagation(event);
 	}
 

 
	// ************************************************************************ 
	// Private Methods
	// *********************************************************************** 

	/*
	 */
 	function fireValueChange(value){
 		for (i = 0; i < valueChangeListenerCount; i++)
	   {
	   		valueChangeListenerList[i].valueChanged(value);
	   }
 	} 

	/*
	 */
	function elementCollapsedFixSelected(collapsedId){
		// If nothing is selected, nothing needs to be fixed
		if(selectedRow == null)
			return;
		
		// Since the id of an element keeps its ancestor trace
		// We check if the selected row is a descendant of the collapsed row
		// by checking if the selected row id starts with the collapsed row id
		// We also make sure that the selected row wasnt collapsed
		if(selectedRow.indexOf(collapsedId) == 0 && selectedRow != collapsedId)
		{
			//alert("elementCollapsedFixSelected");
			document.getElementById(selectedRow).className = "nbceTableUnselectedRow";
			selectedRow = null;
			selectRowValues = null;
			
			fireValueChange(null);
			//changeMenuOptions("Default");
		}
	}
	
	/*
	 * Todo this method can be private
	 * Update selectd row when collapse the tree table.
	 * in this situation, the select row in the treetable will be changed without clicking. 
	 */
 	function allCollapsedFixSelected() {
 		//alert(selectedRow);
 		
	 	// If nothing is selected, nothing needs to be fixed
		if(selectedRow == null)
			return;
			
		// If a root node is selected, then we dont need to do anything
		// Root nodes will not have dashes in the id
		if(selectedRow.substr(14).indexOf("_") == -1)
		{
			return;
		}
		else
		{
			//alert("this.allCollapsedFixSelected");
			// Here we need to unselect
			document.getElementById(selectedRow).className = "nbceTableUnselectedRow";
			selectedRow = null;
			selectRowValues = null;
			
			fireValueChange(null);
			//changeMenuOptions("Default");
		}
 	}
 	
	/*
	 */
	function stopPropagation(thisEvent){
		// For IE
		if(!thisEvent)
			thisEvent = window.event;
	
			
		thisEvent.cancelBubble = true;
			
		// For Mozilla
		if(thisEvent.stopPropagation)
			thisEvent.stopPropagation();
	}

	function setSelectedSwitchIpAddress(_IpAddress){
		document.getElementById(namespace_g+'submitForm:treeTable:selectedSwitchIPAddress').value=_IpAddress;
		
	}

 	
 }
 
 // ************************************************************************ 
// Static Methods&Fields
// *********************************************************************** 
com.ibm.sysmgmt.nbce.gui.viewswitches.TreeTable._instance=null;

/*
 * singleton of treeTable
 */
com.ibm.sysmgmt.nbce.gui.viewswitches.TreeTable.getInstance = function(){
	if(com.ibm.sysmgmt.nbce.gui.viewswitches.TreeTable._instance == null){
		com.ibm.sysmgmt.nbce.gui.viewswitches.TreeTable._instance = new com.ibm.sysmgmt.nbce.gui.viewswitches.TreeTable();
	}
	
	return com.ibm.sysmgmt.nbce.gui.viewswitches.TreeTable._instance;
};


function openAddSWModal(event){

	var addSWButton = document.getElementById(namespace_g+'submitForm:addSwitchButton');
	addSWButton.click();
	
	if (event.stopPropagation) event.stopPropagation();
	else event.cancelBubble = true;
	
	if (event.preventDefault) event.preventDefault();
	else event.returnValue = false;

	
}
 
